/*
 * MultisetContainer.java
 *
 * Created on 22 giugno 2004, 15.21
 */

package it.unive.dsi.pear.plugins;

import java.util.*;

import it.unive.dsi.pear.core.parser.Data;
import it.unive.dsi.pear.core.AbstractContainer;

/**
 * This class models a multiset: each element may appear more than once.
 * @author  Francesco Placella
 */
public class MultisetContainer extends AbstractContainer
{
    private LinkedList container = new LinkedList();
    
    public Object clone()
    {
        MultisetContainer cloned = (MultisetContainer)super.clone();
        cloned.container = (LinkedList)container.clone();
        return cloned;
    }
    
    public boolean add(Data data) { return container.add(data); }
    public boolean contains(Data data) { return container.contains(data); }
    public Collection content() { return container; }
    public boolean delete(Data data) { return container.remove(data); }
    public Data get(Data data) { return container.contains(data) ? data : null; }
    public void clear() { container.clear(); }
    
    public boolean add(Data key, Data data) throws OperationException
    {
        throw new OperationException("operation not implemented");
    }
}
