/*
 * SetContainer.java
 *
 * Created on 8 marzo 2004, 14.29
 */

package it.unive.dsi.pear.plugins;

import java.util.*;

import it.unive.dsi.pear.core.parser.Data;
import it.unive.dsi.pear.core.AbstractContainer;

/**
 * This class models an unordered set.
 * @author  Francesco Placella
 */
public class SetContainer extends AbstractContainer
{
    protected HashMap container = new HashMap();
    
    public Object clone()
    {
        SetContainer cloned = (SetContainer)super.clone();
        cloned.container = (HashMap)container.clone();
        return cloned;
    }
    
    public Data set(Data data)
    {
        String info = data.getInfo();
        if (container.get(info) != null) return (Data)container.put(info, data);
        else return null;
    }
    
    public boolean add(Data data) throws OperationException
    {
        return this.add(data.getInfo(), data);
    }
    
    public boolean add(Data key, Data data) throws OperationException
    {
        return this.add(key.getInfo(), data);
    }

    protected boolean add(Object info, Data data) throws OperationException
    {
        if (container.keySet().contains(info))
            throw new OperationException("data already contained");
        
        container.put(info, data);        
        return true;
    }
    
    public boolean delete(Data data)
    {
        return container.remove(data.getInfo()) != null;
    }

    public boolean contains(Data data) { return container.containsValue(data); }
    public Data get(Data data) { return (Data)container.get(data.getInfo()); }
    public Collection content() { return container.values(); }
    public void clear() { container.clear(); }
}