/*
 * ExternalOperation.java
 *
 * Created on 1 aprile 2004, 15.10
 */

package it.unive.dsi.pear.core;

import it.unive.dsi.pear.core.parser.Container;

/** This interface models an external operation.
 * @author Francesco Placella
 */
public interface ExternalOperation
{    
    /** The name of the method to be invoked (used by the reflection classes).
     */    
    public static final String METHOD_NAME = "perform";
    
    /** The arguments of the method to be invoked (used by the reflection 
     * classes).
     */
    public static final Class[] ARG_CLASSES =
        new Class[]{ Container.class, Container[].class };
    
    /** Performs the requested operation.
    * @param container the container on which perform the operation
    * @param args the arguments of the operation
    * @throws OperationException if any problem is detected during the operation 
    * performing
    * @return an object representing the result of the operation
    */        
    public Object perform(Container container, Container[] args)
        throws Container.OperationException;
    
    /** Gets available to the operation the symbol table related to the 
     * sequential process defining the instruction currently being validated.
     * @param symbolTable the symbol table of the current sequential process
     */    
    public void setSymbolTable(java.util.Map symbolTable);
}
