/*
 * StepLevel.java
 *
 * Created on 15 maggio 2004, 20.22
 */

package it.unive.dsi.pear.core;

import java.util.*;

/**
 *
 * @author  Francesco Placella
 */
public class StepLevel
{
    private static int curLevel = 0;
    
    private final String name;
    private final int level;
    
    private StepLevel(String name)
    {
        this.name = name;
        this.level = curLevel++;
    }
    
    public String toString() { return name; }
    public int getLevel() { return level; }
    public final int hashCode() { return this.getLevel(); }

    public static final StepLevel STRAIGHT_ON_LEVEL =
        new StepLevel("straight on");
    public static final StepLevel SEQ_PROC_LEVEL =
        new StepLevel("sequential process");
    public static final StepLevel INSTRUCTION_LEVEL =
        new StepLevel("instruction");
    public static final StepLevel RULE_LEVEL =
        new StepLevel("rule");
    public static final StepLevel OPERATION_LEVEL =
        new StepLevel("operation");
    
    public static int getMaxLevel() { return curLevel; }
    
    public static final StepLevel[] VALUES =
    {
        STRAIGHT_ON_LEVEL,
        SEQ_PROC_LEVEL,
        INSTRUCTION_LEVEL,
        RULE_LEVEL,
        OPERATION_LEVEL
    };
}
