/*
 * Validation.java
 *
 * Created on 27 settembre 2004, 12.46
 */

package it.unive.dsi.pear.core;

import java.util.*;
import java.io.*;

import it.unive.dsi.pear.util.*;

import it.unive.dsi.pear.log.Log;
import it.unive.dsi.pear.core.parser.Protocol;
import it.unive.dsi.pear.core.parser.ValidationRules;

/**
 *
 * @author  Francesco Placella
 */
public interface Validation extends Parser
{
    public class StoppedException extends InterruptedException {}
    
    public boolean getStep(ValidationOutput vo)
        throws StoppedException;
    public void proceed();
    public void stepBack();
    public boolean validateProtocol(Protocol protocol)
        throws StoppedException, BackTrackingHandler.LimitExcededException;
    
    public boolean isBackStepAvailable();
    public StepLevel getCurStepLevel();
    public void setCurStepLevel(StepLevel curStepLevel);
    public String getErrMsg();
    public Object[] getErrPath();
    public void setFullInfo(boolean fullInfo);
    public String getProtocolName();
    public List getRuleList();
    public boolean isStopped();
    public void setStopped(boolean stopped);
    public ValidationRules getValidationRules();
    public void setValidationRules(ValidationRules validationRules)
        throws InitializationException;
}
