/*
 * ValidationOuput.java
 *
 * Created on 28 aprile 2004, 14.02
 */

package it.unive.dsi.pear.core;

import java.util.*;

import it.unive.dsi.pear.core.parser.Protocol;
import it.unive.dsi.pear.core.parser.ProtocolNode;
import it.unive.dsi.pear.core.parser.Rule;

/** This class implements a data structure usefule to store all the data needed
 * to display an image of the current validation state.
 * @author Francesco Placella
 */
public class ValidationOutput
{
    private Collection containers;
    private String message;
    private Map substMap;
    private Object[] treePath;
    private int firstRow;
    private int lastRow;
    private ProtocolNode instruction;
    private Rule rule;
    private boolean valid = false;
    
    /** Holds value of property protocol. */
    private Protocol protocol;
    
    /** Getter for property message.
     * @return Value of property message.
     *
     */
    public java.lang.String getMessage() {
        return message;
    }
    
    /** Setter for property message.
     * @param message New value of property message.
     *
     */
    public void setMessage(java.lang.String message) {
        this.message = message;
    }
    
    /** Getter for property containers.
     * @return Value of property containers.
     *
     */
    public Collection getContainers() {
        return containers;
    }
    
    /** Setter for property containers.
     * @param containers New value of property containers.
     */
    public void setContainers(Collection containers) {
        this.containers = containers;
    }
    
    /** Getter for property substMap.
     * @return Value of property substMap.
     *
     */
    public Map getSubstMap() {
        return this.substMap;
    }
    
    /** Setter for property substMap.
     * @param substMap New value of property substMap.
     *
     */
    public void setSubstMap(Map substMap) {
        this.substMap = substMap;
    }
    
    /** Getter for property treePath.
     * @return Value of property treePath.
     *
     */
    public java.lang.Object[] getTreePath() {
        return this.treePath;
    }
    
    /** Setter for property treePath.
     * @param treePath New value of property treePath.
     *
     */
    public void setTreePath(java.lang.Object[] treePath) {
        this.treePath = treePath;
    }
    
    /** Getter for property firstRow.
     * @return Value of property firstRow.
     *
     */
    public int getFirstRow() {
        return firstRow;
    }
    
    /** Setter for property firstRow.
     * @param firstRow New value of property firstRow.
     *
     */
    public void setFirstRow(int firstRow) {
        this.firstRow = firstRow;
    }
    
    /** Getter for property lastRow.
     * @return Value of property lastRow.
     *
     */
    public int getLastRow() {
        return lastRow;
    }
    
    /** Setter for property lastRow.
     * @param lastRow New value of property lastRow.
     *
     */
    public void setLastRow(int lastRow) {
        this.lastRow = lastRow;
    }
    
    /** Getter for property instruction.
     * @return Value of property instruction.
     *
     */
    public ProtocolNode getInstruction() {
        return instruction;
    }
    
    /** Setter for property instruction.
     * @param instruction New value of property instruction.
     *
     */
    public void setInstruction(ProtocolNode instruction) {
        this.instruction = instruction;
    }
    
    /** Getter for property rule.
     * @return Value of property rule.
     *
     */
    public Rule getRule() {
        return rule;
    }
    
    /** Setter for property rule.
     * @param rule New value of property rule.
     *
     */
    public void setRule(Rule rule) {
        this.rule = rule;
    }
    
    /** Getter for property valid.
     * @return Value of property valid.
     *
     */
    public boolean isValid() {
        return valid;
    }
    
    /** Setter for property valid.
     * @param valid New value of property valid.
     *
     */
    public void setValid(boolean valid) {
        this.valid = valid;
    }
    
    /** Getter for property protocol.
     * @return Value of property protocol.
     *
     */
    public Protocol getProtocol() {
        return this.protocol;
    }
    
    /** Setter for property protocol.
     * @param protocol New value of property protocol.
     *
     */
    public void setProtocol(Protocol protocol) {
        this.protocol = protocol;
    }
    
}
