/*
 * ETConditions.java
 *
 * Created on 30 settembre 2004, 18.38
 */

package it.unive.dsi.pear.core.evaluationtree;

import java.util.*;

import it.unive.dsi.pear.core.parser.Condition;
import it.unive.dsi.pear.core.parser.Conditions;
import it.unive.dsi.pear.core.parser.Container;
import it.unive.dsi.pear.core.parser.ValidationRulesNode;

/**
 * This class implements the evaluation tree conditions node.
 * @author Francesco Placella
 */
public class ETConditions extends ETOpNode implements Conditions
{    
    public ETConditions(Conditions data) { super(data); }
    
    protected final Conditions getData()
    {
        return (Conditions)this.getDataNode();
    }
    
    protected final Iterator dataIterator()
    {
        return this.getData().conditionIterator();
    }
    
    protected ETNode getChildInstance(ValidationRulesNode node)
    {
        return new ETCondition((Condition)node);
    }

// ----------------------------------------------------------------------------
    
    public String toString()
    {
        return "[" + this.getDefSrcType() + "] conditions";
    }
    
    public boolean evaluate(EvalInfo evalInfo)
        throws Container.OperationException
    {
        evalInfo.setNodeBrand(this.getBrand());
        return super.evaluate(evalInfo);
    }
    
    public final Iterator conditionIterator()
    {
        return this.getNodeIteratorInstance(this, ETCondition.class);
    }
}
