/*
 * ETNotCheck.java
 *
 * Created on 30 settembre 2004, 18.38
 */

package it.unive.dsi.pear.core.evaluationtree;

import it.unive.dsi.pear.core.parser.Container;
import it.unive.dsi.pear.core.parser.NotCheck;

/**
 * This class implements the evaluation tree boolean not node.
 * @author Francesco Placella
 */
public class ETNotCheck extends ETBoolNode
    implements NotCheck
{
    public ETNotCheck(NotCheck data) { super(data); } 
    
    public boolean evaluate(EvalInfo evalInfo)
        throws Container.OperationException
    {
        this.buildPath(evalInfo);
        boolean res = !((ETBoolNode)this.getChildAt(0)).evaluate(evalInfo);        
        this.destroyPath(evalInfo);
        return res;
    }
    
    public String toString() { return "not"; }
    
    protected boolean evaluable(EvalInfo evalInfo)
    {
        return ((ETBoolNode)this.getChildAt(0)).evaluable(evalInfo);
    }
}
