/*
 * ETOrCheck.java
 *
 * Created on 30 settembre 2004, 18.38
 */

package it.unive.dsi.pear.core.evaluationtree;

import it.unive.dsi.pear.core.parser.Container;
import it.unive.dsi.pear.core.parser.OrCheck;

/**
 * This class implements the evaluation tree boolean or node.
 * @author Francesco Placella
 */
public class ETOrCheck extends ETBoolNode
    implements OrCheck
{
    public ETOrCheck(OrCheck data) { super(data); } 
    
    public boolean evaluate(EvalInfo evalInfo)
        throws Container.OperationException
    {
        this.buildPath(evalInfo);
        
        boolean value = false;

        int size = this.getChildCount();
        for (int i = 0; i < size && !value; ++i)
        {
            ETBoolNode boolNode = (ETBoolNode)this.getChildAt(i);
            if (!boolNode.evaluable(evalInfo)) continue;
            value = value || boolNode.evaluate(evalInfo);
        }
        
        this.destroyPath(evalInfo);
        
        return value;
    }
    
    public String toString() { return "or"; }
}
