/*
 * EvalInfo.java
 *
 * Created on 26 marzo 2004, 11.41
 */

package it.unive.dsi.pear.core.evaluationtree;

import it.unive.dsi.pear.core.parser.Container;
import it.unive.dsi.pear.core.parser.Data;
import it.unive.dsi.pear.core.parser.Operation;
import it.unive.dsi.pear.util.BackTrackingHandler;

import java.util.List;
import java.util.Map;


/**
 * This class implements a data structure used to store all thedata needed to
 * evaluate a rule.
 * @author  Francesco Placella
 */
public class EvalInfo
{
    private Object substMapField; 
    
    /** Holds value of property substMap. */
    private Map substMap;
    
    /** Holds value of property btHandler. */
    private BackTrackingHandler btHandler;
    
    /** Holds value of property treePath. */
    private List treePath;
    
    /** Holds value of property evaluator. */
    private Evaluator evaluator;
    
    /** Holds value of property backtrackingNode. */
    private Object backtrackingEntity;
    
    /** Holds value of property autoSubstEnabled. */
    private boolean autoSubstEnabled;
    
    /** Holds value of property nodeBrand. */
    private int nodeBrand = BackTrackingHandler.NO_BRAND;
    
    /** Holds value of property resetAbstract. */
    private boolean resetAbstract;
    
    /** Holds value of property symbolTable. */
    private Map symbolTable;
    
    /** Holds value of property operation. */
    private Operation operation;

    /**
     * Holds value of property instantiatedArguments.
     */
    private Data[] instantiatedArguments;

    /**
     * Holds value of property fullInfo.
     */
    private boolean fullInfo;
    
    /** Creates a new instance of EvalInfo */
    public EvalInfo() {
    }

    /** Getter for property substMap.
     * @return Value of property substMap.
     *
     */
    public Map getSubstMap() {
        return this.substMap;
    }
    
    /** Setter for property substMap.
     * @param substMap New value of property substMap.
     *
     */
    public void setSubstMap(Map substMap) {
        this.substMap = substMap;
    }
    
    /** Getter for property btHandler.
     * @return Value of property btHandler.
     *
     */
    public BackTrackingHandler getBtHandler() {
        return this.btHandler;
    }
    
    /** Setter for property btHandler.
     * @param btHandler New value of property btHandler.
     *
     */
    public void setBtHandler(BackTrackingHandler btHandler) {
        this.btHandler = btHandler;
    }
    
    /** Getter for property treePath.
     * @return Value of property treePath.
     *
     */
    public List getTreePath() {
        return this.treePath;
    }
    
    /** Setter for property treePath.
     * @param treePath New value of property treePath.
     *
     */
    public void setTreePath(List treePath) {
        this.treePath = treePath;
    }
    
    /** Getter for property validationCore.
     * @return Value of property validationCore.
     *
     */
    public Evaluator getEvaluator() {
        return this.evaluator;
    }
    
    /** Setter for property validationCore.
     * @param validationCore New value of property validationCore.
     *
     */
    public void setEvaluator(Evaluator evaluator) {
        this.evaluator = evaluator;
    }
    
    /** Getter for property backtrackingNode.
     * @return Value of property backtrackingNode.
     *
     */
    public Object getBacktrackingEntity() {
        return this.backtrackingEntity;
    }
    
    /** Setter for property backtrackingNode.
     * @param backtrackingNode New value of property backtrackingNode.
     *
     */
    public void setBacktrackingEntity(Object backtrackingEntity) {
        this.backtrackingEntity = backtrackingEntity;
    }
    
    /** Getter for property autoSubstEnabled.
     * @return Value of property autoSubstEnabled.
     *
     */
    public boolean isAutoSubstEnabled() {
        return this.autoSubstEnabled;
    }
    
    /** Setter for property autoSubstEnabled.
     * @param autoSubstEnabled New value of property autoSubstEnabled.
     *
     */
    public void setAutoSubstEnabled(boolean autoSubstEnabled) {
        this.autoSubstEnabled = autoSubstEnabled;
    }
    
    /** Getter for property nodeBrand.
     * @return Value of property nodeBrand.
     *
     */
    public int getNodeBrand() {
        return this.nodeBrand;
    }
    
    /** Setter for property nodeBrand.
     * @param nodeBrand New value of property nodeBrand.
     *
     */
    public void setNodeBrand(int nodeBrand) {
        this.nodeBrand = nodeBrand;
    }
    
    /** Getter for property resetAbstract.
     * @return Value of property resetAbstract.
     *
     */
    public boolean isResetAbstract() {
        return this.resetAbstract;
    }
    
    /** Setter for property resetAbstract.
     * @param resetAbstract New value of property resetAbstract.
     *
     */
    public void setResetAbstract(boolean resetAbstract) {
        this.resetAbstract = resetAbstract;
    }
    
    /** Getter for property symbolTable.
     * @return Value of property symbolTable.
     *
     */
    public Map getSymbolTable() {
        return this.symbolTable;
    }
    
    /** Setter for property symbolTable.
     * @param symbolTable New value of property symbolTable.
     *
     */
    public void setSymbolTable(Map symbolTable) {
        this.symbolTable = symbolTable;
    }
    
    /** Getter for property operation.
     * @return Value of property operation.
     *
     */
    public Operation getOperation() {
        return this.operation;
    }
    
    /** Setter for property operation.
     * @param operation New value of property operation.
     *
     */
    public void setOperation(Operation operation) {
        this.operation = operation;
    }
    
    public Object getSubstMapField()
    {
        return substMapField;
    }
    
    /** Setter for property substMapField.
     * @param substMapField New value of property substMapField.
     *
     */
    public void setSubstMapField(Object substMapField) {
        this.substMapField = substMapField;;
    }

    /**
     * Getter for property instantiatedRule.
     * @return Value of property instantiatedRule.
     */
    public Data[] getInstantiatedArguments()  {

        return this.instantiatedArguments;
    }

    /**
     * Setter for property instantiatedRule.
     * @param instantiatedRule New value of property instantiatedRule.
     */
    public void setInstantiatedArguments(Data[] instantiatedArguments)
    {
        this.instantiatedArguments = instantiatedArguments;
    }

    /**
     * Getter for property fullInfo.
     * @return Value of property fullInfo.
     */
    public boolean isFullInfo() {

        return this.fullInfo;
    }

    /**
     * Setter for property fullInfo.
     * @param fullInfo New value of property fullInfo.
     */
    public void setFullInfo(boolean fullInfo) {

        this.fullInfo = fullInfo;
    }
    
}
