/*
 * AbstractTaggedData.java
 *
 * Created on 28 marzo 2004, 23.37
 */

package it.unive.dsi.pear.core.parser;

import java.util.*;

/** This class implements the behaviour of the <CODE>:::</CODE> construct.
 * @author Francesco Placella
 */
public class AbstractTaggedData extends AbstractData
{
    public static final AbstractTaggedData ABSTRACT_TAGGED_DATA =
        new AbstractTaggedData();
    
    /** Creates a new instance of <CODE>AbstractTaggedData</CODE>. */    
    public AbstractTaggedData() { super(":::"); }
    
    public boolean putMatching(Map substMap, List iList)
    {
        List taggedList = new LinkedList();
        Iterator it = iList.iterator();
        while (it.hasNext())
        {
            Data data = (Data)it.next();
            if (data != null)
            {
                if (data.containsTagged())
                {
                    taggedList.add(data);
                    it.remove();
                }
            }
            else it.remove();
        }
 
        if (!iList.isEmpty())
        {
            taggedList.add(AbstractData.ABSTRACT_DATA);
            AbstractData.ABSTRACT_DATA.matchAbstract(substMap, iList);
        }
   
        return this.matchAbstract(substMap, taggedList);
    }
    
    public boolean subst(Map substMap, List contentList)
    {
        super.subst(substMap, contentList);
        AbstractData ad = AbstractData.ABSTRACT_DATA;
        ad.subst(substMap, contentList);
        contentList.remove(ad);
        return false;
    }
}
