/*
 * CipherInstruction.java
 *
 * Created on 1 settembre 2004, 19.38
 */

package it.unive.dsi.pear.core.parser;

/** This interface models a generic cipher instruction.
 * @author Francesco Placella
 */
public interface CipherInstruction extends Instruction
{
    /** Returns the class implementing the complement-related cipher 
     * instruction. */    
    public Class getComplementClass();
    /** Returns a string representation of the ciphertext being the argument
     * of the cipher instruction. */    
    public String getCiphertextImage();
    /** Returns the argument of the cipher instruction. */    
    public Ciphertext getCiphertext();
    /** Checks if the given instruction is may be a complement of the current 
     * one. */
    public boolean isCompatible(CipherInstruction ci);
    /** Returns <CODE>true</CODE> if the instruction is an encryption,
     * <CODE>false</CODE> if it's a decryption. */    
    public boolean isEncrypt();
}
