/*
 * Condtions.java
 *
 * Created on 30 settembre 2004, 17.27
 */

package it.unive.dsi.pear.core.parser;

/** This interface model a condition node
 * @author Francesco Placella
 */
public interface Condition extends Operations
{
    /** Returns an iterator over the child clauses. */    
    public java.util.Iterator clauseIterator();
    /** Returns the value of the requested result.
     * @return the value of the requested result or
     * <CODE>null</CODE> if undefined
     */    
    public Boolean getResultRequested();
    /** Returns the value of the universal quantification directive.
     * @return the value of the universal quantification directive or
     * <CODE>null</CODE> if undefined
     */    
    public Boolean getUniversalQuantification();
    /** Checks if the reset abstract directive is defined. */    
    public boolean isResetAbstract();
}
