/*
 * Container.java
 *
 * Created on 8 marzo 2004, 12.16
 */

package it.unive.dsi.pear.core.parser;

import java.util.*;

/** This interface models a generic container.
 * @author Francesco Placella
 * @see it.unive.dsi.pear.core.AbstractContainer
 */
public interface Container
    extends it.unive.dsi.pear.util.CloneableElement
{
    public class OperationException extends Exception
    {
        public OperationException(Throwable cause) { super(cause); }
        public OperationException(String msg) { super(msg); }
    }
    
    public boolean add(Data data) throws OperationException;
    public boolean add(Data key, Data data) throws OperationException;
    public boolean contains(Data data);    
    public boolean delete(Data data);
    public Data get(Data data);
    public boolean autoPatternMatch(Data arg, Data data, Map substMap);
    
    public Collection content();
    public it.unive.dsi.pear.util.CloneableIterator infoIterator();
    public Object[] toArray();
    public void clear();

    public String getContentImage();
    public String getName();
    public void setName(String name);
}
