/*
 * Decrypt.java
 *
 * Created on 27 agosto 2004, 0.58
 */

package it.unive.dsi.pear.core.parser;

/** This class models a decryption primitive.
 * @author Francesco Placella
 */
public class Decrypt extends CipherInstructionImpl
{
    public static final String DECRYPT = "decrypt";    
    
    /** Creates a new instance of <CODE>Decrypt</CODE>.
     * @param cd the ciphertext to be decrypted
     */
    public Decrypt(Ciphertext cd)
    {
        super(DECRYPT, cd);
        cd.setEncrypted(false);
    }
    
    public String toString()
    {
        StringBuffer buf = new StringBuffer(DEFAULT_BUF_SIZE);
        
        buf.
            append(DECRYPT).append(" ").
            append(this.getCiphertext().getInfo()).
            append(" as ").append(this.getCiphertextImage());
        
        return buf.toString();
    }
    
    public Class getComplementClass() { return Encrypt.class; }
}
