/*
 * Encrypt.java
 *
 * Created on 27 agosto 2004, 0.36
 */

package it.unive.dsi.pear.core.parser;

/** This class models and encryption primitive.
 * @author Francesco Placella
 */
public class Encrypt extends CipherInstructionImpl
{
    public static final String ENCRYPT = "encrypt";
    
    /** Creates a new instance of <CODE>Encrypt</CODE>.
     * @param cd the ciphertext to be encrypted
     */
    public Encrypt(Ciphertext cd)
    {
        super(ENCRYPT, cd);
        cd.setEncrypted(true);
    }
    
    public String toString()
    {
        StringBuffer buf = new StringBuffer(DEFAULT_BUF_SIZE);
        
        buf.
            append(ENCRYPT).append(" ").
            append(this.getCiphertextImage()).
            append(" as ").append(this.getCiphertext().getInfo());
        
        return buf.toString();
    }
    
    public Class getComplementClass() { return Decrypt.class; }
}
