/*
 * EnumType.java
 *
 * Created on 18 gennaio 2004, 22.24
 */

package it.unive.dsi.pear.core.parser;

/** This abstract class models a generic enumeration of the possible type
 * assignable to the identifers belonging to a generic source.
 * @author Francesco Placella
 */
public abstract class EnumType implements Comparable
{
    private int typeCode;

    /** Initializes the <CODE>typeCode</CODE> field. */    
    protected EnumType(int typeCode) { this.typeCode = typeCode; }
    /** Returns the type code associated to the current type. */    
    protected int getTypeCode() { return this.typeCode; }
    
    public int compareTo(Object o)
    {
        EnumType et = (EnumType)o;
        return this.typeCode - et.typeCode;
    }
    
    public boolean equals(Object o)
    {
        if (o == null) return false;
        if (this.getClass() != o.getClass()) return false;
        return this.getTypeCode() == ((EnumType)o).getTypeCode();
    }

    public int hashCode() { return this.typeCode; }
}
