/*
 * Errors.java
 *
 * Created on 1 febbraio 2004, 16.11
 */

package it.unive.dsi.pear.core.parser;

/** This class defines the error messages generated by the parser.
 * @author Francesco Placella
 */
public class Errors
{
    public static final String UNDECLARED_IDENTIFIER =
        "undeclared identifier";
    public static final String ALREADY_DECLARED_IDENTIFIER =
        "already declared identifier";
    public static final String WRONG_TYPE =
        "wrong type (expected)";
    public static final String WRONG_PRINCIPAL =
        "wrong principal (expected)";
    public static final String DUPLICATE_PRINCIPAL =
        "duplicate principal";
    public static final String UNDECLARED_SEQ_PROCESS =
        "undeclared sequential process";
    public static final String WRONG_ARG_NUMBER =
        "wrong argument number (expected)";
    public static final String WRONG_KEY_DECL =
        "wrong key argument in sequential process instantiation";
    public static final String DUPLICATE_ABSTRACT_DATA =
        "duplicate abstract data";
    public static final String FORBIDDEN_TAG =
        "tag is not permitted here";
    public static final String UNDECLARED_KEY =
        "undeclared key";
    public static final String WRONG_COUPLING =
        "wrong instruction coupling";
    
    /** Creates an error message formatting the given arguments.
     * @param err the error message
     * @param param the parameter involved in the error
     * @return the error message
     */    
    public static final String getMsg(String err, String param)
    {
      return err + ": \"" + param + "\"";
    }
    
    /** Creates an error message formatting the given arguments. */    
    public static final String getMsg(String err, String param1, String param2)
    {
      return err + ": \"" + param1 + "\" (" + param2 + ")";
    }
}
