/*
 * GenericToken.java
 *
 * Created on 28 settembre 2004, 21.27
 */

package it.unive.dsi.pear.core.parser;

/** This interface models a generic token.
 * @author Francesco Placella
 */
public interface GenericToken
{
    /** Returns an integer identifying the kind of the token. */    
    public int getKind();
    /** Returns the next token. */    
    public GenericToken getNext();
    /** Returns the beginning column of the token. */    
    public int getBeginColumn();
    /** Returns the beginning line of the token. */    
    public int getBeginLine();
    /** Returns the ending column of the token. */    
    public int getEndColumn();
    /** Returns the ending line of the token. */    
    public int getEndLine();
}