/*
 * Instruction.java
 *
 * Created on 1 settembre 2004, 19.22
 */

package it.unive.dsi.pear.core.parser;

import java.util.*;

/** This interface models a generic instruction.
 * @author Francesco Placella
 */
public interface Instruction extends Data 
{
    public static final String SEPARATOR = ".";
    
    /** Checks if the current instruction matches the give one.
     * @param instr the instruction to be matched.
     * @return the substitution map if the matching is successful, 
     * <CODE>null</CODE> otherwise
     */
    public Map appliesTo(Instruction instr);
    
    /** Checks if the current instruction matches the give one.
     * @param instr the instruction to be matched.
     * @param thisId an identity associated to this instruction
     * @param instrId an identity associtaed to the instruction to be matched
     * @return the substitution map if the matching is successful,
     * <CODE>null</CODE> otherwise
     */
    public Map appliesTo(Instruction instr, String thisId, Data instrId);
    
    /** Returns an array containing the arguments of the instruction. */    
    public Data[] getData();
    /** Sets the arguments of the instruction */    
    public void setData(Data[] data);

    /**
     * Getter for property nil.
     * @return Value of property nil.
     */
    public boolean isNil();
}
