/*
 * InstructionNode.java
 *
 * Created on 27 settembre 2004, 15.23
 */

package it.unive.dsi.pear.core.parser;

/** This interface models an instruction node.
 * @author Francesco Placella
 */
public interface InstructionNode extends ProtocolNode
{
    /** Returns the complement node. */    
    public InstructionNode getComplement();
    /** Returns the label used to couple the complement instructions. */    
    public String getInstrLabel();
    /** Returns <CODE>true</CODE> if the node is child of a
     * <CODE>SequentialProcess</CODE> defined after the parent of the
     * complement instruction node, <CODE>false</CODE> otherwise.
     */    
    public boolean isForwardComplement();
    /** Returns the <CODE>SequentialProcess</CODE> defining the current 
     * instruction. */    
    public SequentialProcess getSequentialProcess();
    /** Sets the instruction data decorating the current node. */    
    public void setInstruction(Instruction instr);
}
