/*
 * KeyInstance.java
 *
 * Created on 1 ottobre 2004, 15.06
 */

package it.unive.dsi.pear.core.parser;

/** This interface models an asymmetric key instantiation. Please note that a
 * symmetric key instance is a <I>simple</I> data element.
 * @author Francesco Placella
 */
public interface KeyInstance extends Data
{
    /** Returns <CODE>true</CODE> if the current instance models a public key,
     * <CODE>false</CODE> if it models a private key.
     */    
    public boolean isPublic();
    /** Returns the data element representing the key pair. */    
    public Data getKey();
}
