/*
 * KeyType.java
 *
 * Created on 23 agosto 2004, 18.23
 */

package it.unive.dsi.pear.core.parser;

/**
 * This class enumerates the types that a key ay assume.
 * @author  Francesco Placella
 */
public class KeyType
{
    private String kind;
    
    public static final KeyType NO_KEY = new KeyType("NoKey");
    public static final KeyType SYM_KEY = new KeyType("SymKey");
    public static final KeyType KEY_PAIR = new KeyType("AsymKey");
    public static final KeyType PRIV_KEY = new KeyType("PrivAsymKey");
    public static final KeyType PUB_KEY = new KeyType("PubAsymKey");    
    
    public String toString() { return kind; }
    public boolean equals(Object obj)
    {
        return obj instanceof KeyType && ((KeyType)obj).kind.equals(kind);
    }
    
    public KeyType getComplement()
    {
        if (this == PUB_KEY) return PRIV_KEY;
        else if (this == PRIV_KEY) return PUB_KEY;
        return this;
    }
    
    public static KeyType getMatchingValue(String value)
    {
        if (SYM_KEY.toString().equals(value)) return SYM_KEY;
        if (KEY_PAIR.toString().equals(value)) return KEY_PAIR;
        if (PRIV_KEY.toString().equals(value)) return PRIV_KEY;
        if (PUB_KEY.toString().equals(value)) return PUB_KEY;
        
        return null;
    }
    
    private KeyType(String kind) { this.kind = kind; }
}
