/*
 * LabeledAbstractData.java
 *
 * Created on 19 gennaio 2005, 13.26
 */

package it.unive.dsi.pear.core.parser;

import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 *
 * @author Fancesco Placella
 */
public class LabeledAbstractData extends AbstractData
{
    private String label;
    
    /** Creates a new instance of LabeledAbstractData */
    public LabeledAbstractData(String label)
    {
        super("{" + label + "}");
        this.label = label;
    }
    
    public boolean subst(Map substMap, List contentList)
    {
        String info = this.getInfo();
        Object obj = substMap.get(info);
        
        if (obj == null)
        {
            obj = substMap.get(label);
            if (obj == null) return true;
        }
        
        if (obj instanceof Data)
            substMap.put(info, Arrays.asList(new Data[]{ (Data)obj }));

        return super.subst(substMap, contentList);
    }
}
