/*
 * Operation.java
 *
 * Created on 1 settembre 2004, 23.33
 */

package it.unive.dsi.pear.core.parser;

/** This interface models an operation node.
 * @author Francesco Placella
 */
public interface Operation extends ValidationRulesNode
{
    /** Returns the name of the container. */    
    public String getContainerName();
    /** Returns the name of the operation. */    
    public String getOperationName();
    /** Returns an array representing the arguments of the operation. */    
    public Data[] getArguments();    
    /** Checks if the operation is native or external. */    
    public boolean isNative();
    /** Returns a string representation of the operation with the given 
     * container name and arguments. */
    public String toString(String containerName, Object[] arguments);
}
