/*
 * OperationSourceType.java
 *
 * Created on 27 febbraio 2004, 12.58
 */

package it.unive.dsi.pear.core.parser;

/**
 * This class enumerates the types an operation source may assume.
 * @author Francesco Placella
 */
public class OperationSourceType
{
    private String image;

    public static final OperationSourceType EXTERNAL =
        new OperationSourceType("external");
    public static final OperationSourceType NATIVE =
        new OperationSourceType("native");
    
    protected OperationSourceType(String image) { this.image = image; }
    protected String getImage() { return this.image; }
    
    public boolean equals(Object o)
    {
        if (!(o instanceof OperationSourceType) || o == null) return false;
        return this.image.equals(((OperationSourceType)o).image);
    }

    public String toString() { return this.getImage(); }
    
    public int hashCode() { return this.getImage().hashCode(); }
}
