/*
 * Parser.java
 *
 * Created on 30 settembre 2004, 23.39
 */

package it.unive.dsi.pear.core.parser;

/** This interface models a generic parser.
 * @author Francesco Placella
 */
public interface Parser
{
    /** Returns the root node of the parse tree of the current source.
     * @throws ParseException if any syntax error is detected
     */    
    public javax.swing.tree.TreeNode getParseTree() throws ParseException;
    /** Defines the tag sets allowed as components  of a message. */    
    public void setDefinedTags(String[][] definedTags);
    /** Sets the current logger. */    
    public void setLog(it.unive.dsi.pear.log.Log log);
    /** Returns the current symbol table. */    
    public SymbolTable getSymbolTable();
    /** Converts the given semantic exception into a warning. */
    public void warning(final SemanticException se);
    /** Provides a data-representation of a string */
    public Data toData(String s);
}
