/*
 * ProtocolNode.java
 *
 * Created on 27 settembre 2004, 11.53
 */

package it.unive.dsi.pear.core.parser;

/** This interface models a generic protocol node.
 * @author Francesco Placella
 */
public interface ProtocolNode extends TreeNode
{
    /** Checks if the current node is an instruction node. */    
    public boolean isInstructionNode();
    /** Return the instruction data associated with the current node. */    
    public Instruction getInstruction();
    /** Returns the decoration of the current node. */    
    public Object getDecoration();
    /** Sets a decoration for the current node. */    
    public void setDecoration(Object decoration);
    /** Returns the instruction separator currently used. */    
    public String getSeparator();
}
