/*
 * Rule.java
 *
 * Created on 1 settembre 2004, 22.01
 */

package it.unive.dsi.pear.core.parser;

import java.util.*;

/** This interface models a generic rule.
 * @author Francesco Placella
 */
public interface Rule
    extends it.unive.dsi.pear.util.CloneableElement, ValidationRulesNode
{
    /** Returns the defined conditions. */    
    public Conditions getConditions();
    /** Returns the defined actions. */    
    public Operations getActions();
    
    /** Returns the rule name. */    
    public String getName();
    /** Returns the rule identity. */    
    public String getIdentity();
    /** Returns the instruction on which the current rule is defined. */    
    public Instruction getInstruction();
}
