/*
 * SemanticException.java
 *
 * Created on 19 febbraio 2004, 16.33
 */

package it.unive.dsi.pear.core.parser;

/**
 * This exception reports a semantic problem.
 * @author  checco
 */
public class SemanticException extends RuntimeException
{
    private final GenericToken token;
    private final String image;
    
    /** Creates a new instance of <CODE>SemanticException</CODE>.
     * @param msg the semantic problem
     */
    public SemanticException(String msg) { this(msg, (GenericToken)null); }
    
    /** Creates a new instance of <CODE>SemanticException</CODE>.
     * @param msg the semantic problem
     * @param token the token that generated the exception
     */
    public SemanticException(String msg, GenericToken token)
    {
        super(msg);
        this.token = token;
        this.image = null;
    }
    /** Creates a new instance of <CODE>SemanticException</CODE>.
     * @param msg the semantic problem
     * @param image the string image of the token that genrated the exception
     */    
    public SemanticException(String msg, String image)
    {
        super(msg);
        this.token = null;
        this.image = image;
    }
    
    public GenericToken getToken() { return token; }
    public String getImage() { return image; }
}
