/*
 * TagType.java
 *
 * Created on 15 agosto 2004, 17.31
 */

package it.unive.dsi.pear.core.parser;

import java.lang.reflect.*;

/** This class enumerates the tag types that can be assigned to an identifier.
 * @author Francesco Placella
 */
public class TagType
{
    private String type;
    
    public static final TagType KEY = new TagType("KeyTag");
    public static final TagType TYPE = new TagType("TypeTag");
    public static final TagType NONCE = new TagType("NonceTag");
    public static final TagType MESSAGE = new TagType("MessageTag");
    public static final TagType IDENTITY = new TagType("IdentityTag");
    public static final TagType CIPHERTEXT = new TagType("CiphertextTag");    
    
    public String toString() { return type; }
    public boolean equals(Object obj)
    {
        return obj instanceof TagType && ((TagType)obj).type.equals(type);
    }
    
    /** Returns the tag type corresponding to the given value. */    
    public static TagType getMatchingValue(String value)
    {
        try
        {
            Class tt = TagType.class;
            String fld = value.substring(0, value.length() - 3);
            Field field = tt.getField(fld.toUpperCase());
            return (TagType)field.get(tt);
        }
        catch (Exception ex) { return null; }
    }
    
    private TagType(String type) { this.type = type; }
}
