/*
 * ValidationRules.java
 *
 * Created on 27 settembre 2004, 12.35
 */

package it.unive.dsi.pear.core.parser;

import java.util.*;

/** This interface models the root node of the validation rule parse tree.
 * @author Francesco Placella
 */
public interface ValidationRules extends ValidationRulesNode
{
    /** Returns an iterator over the child rules. */    
    public Iterator ruleIterator();
    /** Returns the symbol table associated with the current parse tree. */    
    public SymbolTable getSymbolTable();
    /** Returns the tag set definition.
     * @return an array of string arrays each one containing a tag declaration
     */    
    public String[][] getDefinedTags();
    /** Returns the declaration of the containers: each name is mapped to its 
     * class. */    
    public Map getContainerMap();
    /** Returns the tag declaration: each tag is mapped to its type. */    
    public Map getTagTypes();
    /** Returns the maximum tag number found in all the messages appearing in 
     * the validation rules.
     */    
    public int getMaxTagNumber();
    /** Returns the minimum tag number found in all the messages appearing in
     * the validation rules.
     */    
    public int getMinTagNumber();
    /** Returns a description of the rule system
     */
    public String getDescription();
    
}
