/*
 * ValueDataImpl.java
 *
 * Created on 9 gennaio 2005, 17.51
 */

package it.unive.dsi.pear.core.parser;

import java.util.*;

/** This class is a straightforward implementation of ValueData.
 * @author Francesco Placella
 */
public class ValueDataImpl extends SimpleData implements ValueData
{
    private Data value;
    
    /** Creates a new instance of <CODE>ValueData</CODE>.
     * @param value the string value to be stored
     */
    public ValueDataImpl(String info, Data value)
    {
        super(info);
        this.value = value;
    }
    public ValueDataImpl(String info, String value)
    {
        super(info);
        this.value = new SimpleData(value);
    }
    
    public boolean putMatching(Map substMap, List iList)
    {
        Class rClass = this.getClass();
        ListIterator it = iList.listIterator();
        while (it.hasNext())
        {
            Data iData = (Data)it.next();
            if (iData != null && rClass == iData.getClass())
            {
                if (!super.putMatching(substMap, Arrays.asList(new Data[]{ iData })))
                    return false;
                
                String value = this.getValue(); 
                String ivalue = ((ValueData)iData).getValue();
                if (!value.equals(ivalue)) return false;
                
                it.set(null);
                return true;
            }            
        }
        return false;
    }
    
    public String toString() { return this.getInfo() + " = " + value; }
    
    public String getValue() { return value.toString(); }
    public Data getDataValue() { return value; }
}
