/* Generated By:JJTree: Do not edit this line. ASTInstruction.java */

package it.unive.dsi.pear.core.parser.rospi;

import java.util.*;

import it.unive.dsi.pear.core.parser.*;

/** This class is a straightforward implementation of
 * <CODE>InstructionNode</CODE>.
 * @author Francesco Placella
 */
public class ASTInstruction extends RoSpiNode
    implements InstructionNode
{
    /** Holds value of property instruction. */
    private Instruction instruction;
    
    /** Holds value of property instrId. */
    private String instrId;
    
    /** Holds value of property lastClone. */
    private ASTInstruction lastClone = null;
    
    /** Holds value of property complement. */
    private ASTInstruction complement = null;
    
    /** Holds value of property forwardComplement. */
    private boolean forwardComplement;
    
    public ASTInstruction(int id) {
        super(id);
    }
    
    public ASTInstruction(RoSpi p, int id) {
        super(p, id);
    }
    
    public Object clone()
    {
        ASTInstruction cloned = (ASTInstruction)super.clone();
        cloned.instruction = (Instruction)instruction.clone();
        cloned.complement = null;
        return lastClone = cloned;
    }
    
    /** Getter for property instruction.
     * @return Value of property instruction.
     *
     */
    public Instruction getInstruction() {
        return this.instruction;
    }
    
    /** Setter for property instruction.
     * @param instruction New value of property instruction.
     *
     */
    public void setInstruction(Instruction instruction) {
        this.instruction = instruction;
    }
    
    public final String toString()
//    public String toString(Instruction instruction)
    {
        if (instruction != null)
            return instruction + this.getSeparator();
        else
            return null;
    }
    
    /** Getter for property instrId.
     * @return Value of property instrId.
     *
     */
    public String getInstrLabel() {
        return this.instrId;
    }
    
    /** Setter for property instrId.
     * @param instrId New value of property instrId.
     *
     */
    public void setInstrId(String instrId) {
        this.instrId = instrId;
    }
    
    /** Getter for property lastClone.
     * @return Value of property lastClone.
     *
     */
    public ASTInstruction getLastClone() {
        return this.lastClone;
    }
    
    /** Getter for property sequentialProcess.
     * @return Value of property getSequentialProcess.
     *
     */
    public SequentialProcess getSequentialProcess() {
        return (SequentialProcess)this.jjtGetParent();
    }
    
    /** Getter for property complement.
     * @return Value of property complement.
     *
     */
    public InstructionNode getComplement()
    {
        String iid;
        if (complement == null && (iid = this.getInstrLabel()) != null)
        {
            ASTProtocolNarration pn = 
                (ASTProtocolNarration)this.getSequentialProcess().getProtocol();
            Map instrIdMap = pn.getInstrIdMap();

            Instruction instr = this.getInstruction();
            List pair = (List)instrIdMap.get(iid);
            
            if (pair != null)
            {
                ASTInstruction ai = (ASTInstruction)pair.get(0);
                forwardComplement = !instr.equals(ai.getInstruction());
                int index = forwardComplement ? 0 : 1;
                complement = (ASTInstruction)pair.get(index);
                complement.forwardComplement = !forwardComplement;
            }
        }
        
        return complement;
    }
    
    /** Clears the current complement relationship.
     * @return the previous complement if any
     */    
    ASTInstruction resetComplement()
    {
        ASTInstruction compl = null;
        if (complement != null)
        {
            compl = complement;
            compl.complement = null;
            complement = null;
        }
        return compl;    
    }
    
    /** Getter for property forwardComplement.
     * @return Value of property forwardComplement.
     *
     */
    public boolean isForwardComplement()
    {
        if (complement == null) this.getComplement();        
        return this.forwardComplement;
    }
}
