/* Generated By:JJTree: Do not edit this line. ASTprotocolNarration.java */

package it.unive.dsi.pear.core.parser.rospi;

import java.util.*;

import it.unive.dsi.pear.util.*;
import it.unive.dsi.pear.core.parser.*;

/** This class is a straightforward implementation of
 * <CODE>Protocol</CODE>.
 * @author Francesco Placella
 */
public class ASTProtocolNarration extends RoSpiNode implements Protocol
{
    private static final int BUFFER_SIZE = 500;
    private static final ASTSequentialProcessDef[] SP_ARRY = {};
    
    private static final StatisticsComparator STATISTICS_COMPARATOR =
        new StatisticsComparator();
    
    private Map seqProcesses = new HashMap();
    
    /** Holds value of property protocolName. */
    private String protocolName;
    
    /** Holds value of property instrIdMap. */
    private Map instrIdMap = null;

    /** Holds value of property taggings. */
    private Protocol[] taggings;
    
    /** Holds value of property tagging. */
    private boolean tagging = false;
    
    /** Holds value of property associatedRules. */
    private Collection associatedRules;
    
    /** Holds value of property description. */
    private String description;
    
    public ASTProtocolNarration(int id) { super(id); }
    public ASTProtocolNarration(RoSpi p, int id) { super(p, id); }

    public Object clone()
    {
        ASTProtocolNarration cloned = (ASTProtocolNarration)super.clone();
        
        cloned.instrIdMap = new HashMap(instrIdMap.size());
        Iterator it = instrIdMap.entrySet().iterator();
        while (it.hasNext())
        {
            Map.Entry me = (Map.Entry)it.next();

            List idList = (List)me.getValue();
            List clonedIdList = new ArrayList(idList.size());
            Iterator jt = idList.iterator();
            while (jt.hasNext())
            {
                ASTInstruction instr = (ASTInstruction)jt.next();
                clonedIdList.add(instr.getLastClone());
            }

            cloned.instrIdMap.put(me.getKey(), clonedIdList);
        }
        
        cloned.seqProcesses = new HashMap(seqProcesses.size());
        it = cloned.seqProcIterator();
        while (it.hasNext())
        {
            it.unive.dsi.pear.core.parser.Node n = 
                (it.unive.dsi.pear.core.parser.Node)it.next();
            cloned.seqProcesses.put(n.toString(), n);
        }
        
        return cloned;
    }

    public final Comparator getStatisticsComparator()
    {
        return STATISTICS_COMPARATOR;
    }
    
    public void jjtAddChild(it.unive.dsi.pear.core.parser.Node n, int i)
    {
        super.jjtAddChild(n, i);
        if (n instanceof ASTSequentialProcessDef)
            seqProcesses.put(n.toString(), n);
    }
   
    public String toString()
    {
        return "Protocol " + this.protocolName + ":\n";
    }
    
    public final CloneableIterator seqProcIterator()
    {
        return this.getNodeIteratorInstance(this, ASTSequentialProcessDef.class);
    }
    
    public final Iterator keyBindingIterator()
    {
        return this.getNodeIteratorInstance(this, ASTKeyBinding.class);
    }
    
    public final Iterator callIterator()
    {
        return this.getNodeIteratorInstance(this, ASTSequentialProcessInst.class);
    }
    
    public int hashCode()
    {
        return this.stringDump(STRINGDUMP_PREFIX).hashCode();
    }

    /* updateInstrIdMap builds or updates the map of the instructions coupled
     * through labels: this map is used to link complement nodes.
     */
    private void updateInstrIdMap()
    {
        instrIdMap.clear();
        
        Iterator it = this.seqProcIterator();
        while (it.hasNext())
        {
            ASTSequentialProcessDef sp = (ASTSequentialProcessDef)it.next();
            Iterator jt = sp.instrIterator();
            while (jt.hasNext())
            {
                ASTInstruction instruction = (ASTInstruction)jt.next();
                String id = instruction.getInstrLabel();

                if (id != null)
                {
                    List pair = (List)instrIdMap.get(id);
                    if (pair == null)
                    {
                        pair = new ArrayList(RoSpi.PRINCIPAL_NUMBER);
                        instrIdMap.put(id, pair);
                    }
                    
                    pair.add(instruction);
                    instruction.resetComplement();
                }
            }
        }
    }
    
    public void reorderSeqProcesses(SequentialProcess[] sps)
    {
        Iterator it = new ArrayIterator(sps);
        NodeIterator jt = (NodeIterator)this.seqProcIterator();
        while (it.hasNext() && jt.hasNext())
        {
            jt.next();
            String s = it.next().toString();
            it.unive.dsi.pear.core.parser.Node n = 
                (it.unive.dsi.pear.core.parser.Node)seqProcesses.get(s);
            if (n != null) children[jt.getIndex()] = (TreeNode)n;
        }
        
        this.updateInstrIdMap();
    }
    
    public Instruction getInstruction() { return null; }
    
    public String getProtocolImage()
    {
        String prefix = "";
        StringBuffer buf = new StringBuffer(BUFFER_SIZE);
        buf.append(this.toString()).append("\n");
        boolean instantiation = false;
        boolean keyBinding = true;
        
        if (children != null)
        {
            Iterator it = this.childrenIterator();
            while (it.hasNext())
            {
                RoSpiNode n = (RoSpiNode)it.next();
                if (!instantiation && !(n instanceof ASTSequentialProcessDef))
                {
                    instantiation = true;
                    buf.append("\nstart.\n");
                }

                if (keyBinding && instantiation &&
                    !(n instanceof ASTKeyBinding))
                {
                    keyBinding = false;
                    buf.append("( ");
                }
                
                if (n != null)
                {
                    buf.append(n.stringDump(prefix + " "));
                    if (!keyBinding)
                        if (it.hasNext()) buf.append("| ");
                        else buf.append(")");
                }
            }
        }

        buf.append("\n");
        
        return buf.toString();
    }
    
    /** Getter for property protocolName.
     * @return Value of property protocolName.
     *
     */
    public String getProtocolName() {
        return this.protocolName;
    }
    
    /** Setter for property protocolName.
     * @param protocolName New value of property protocolName.
     *
     */
    public void setProtocolName(String protocolName) {
        this.protocolName = protocolName;
    }

    /** Getter for property instrIdMap.
     * @return Value of property instrIdMap.
     *
     */
    Map getInstrIdMap() {
        return instrIdMap;
    }
    
    /** Setter for property instrIdMap.
     * @param instrIdMap New value of property instrIdMap.
     *
     */
    void setInstrIdMap(java.util.Map instrIdMap) {
        this.instrIdMap = instrIdMap;
    }
    
    /** Getter for property taggings.
     * @return Value of property taggings.
     *
     */
    public Protocol[] getTaggings() {
        return this.taggings;
    }
    
    /** Setter for property taggings.
     * @param taggings New value of property taggings.
     *
     */
    public void setTaggings(Protocol[] taggings) {
        this.taggings = taggings;
    }
    
    /** Getter for property tagging.
     * @return Value of property tagging.
     *
     */
    public boolean isTagging() {
        return this.tagging;
    }
    
    /** Setter for property tagging.
     * @param tagging New value of property tagging.
     *
     */
    public void setTagging(boolean tagging) {
        this.tagging = tagging;
    }
    
    /** Getter for property associatedRules.
     * @return Value of property associatedRules.
     *
     */
    public Collection getAssociatedRules() {
        return this.associatedRules;
    }
    
    /** Setter for property associatedRules.
     * @param associatedRules New value of property associatedRules.
     *
     */
    public void setAssociatedRules(Collection associatedRules)
    {
        this.associatedRules = associatedRules;
    }    
    
    /** Getter for property description.
     * @return Value of property description.
     *
     */
    public String getDescription() {
        return this.description;
    }
    
    /** Setter for property description.
     * @param description New value of property description.
     *
     */
    public void setDescription(String description) {
        this.description = description;
    }
    
}

/** This class implements a statistics comparator used to reorder the
 * sequential processes according to their statistics.
 */
class StatisticsComparator implements Comparator
{
    public int compare(Object o1, Object o2)
    {
        ASTSequentialProcessDef sp1 = (ASTSequentialProcessDef)o1;
        ASTSequentialProcessDef sp2 = (ASTSequentialProcessDef)o2;
        return sp2.getStatistics() - sp1.getStatistics();
    }
}
    
