/* Generated By:JJTree: Do not edit this line. ASTSequentialProcessDef.java */

package it.unive.dsi.pear.core.parser.rospi;

import java.util.*;

import it.unive.dsi.pear.util.*;
import it.unive.dsi.pear.core.parser.*;

/** This class is a straightforward implementation of
 * <CODE>SequentialProcess</CODE>.
 * @author Francesco Placella
 */
public class ASTSequentialProcessDef extends RoSpiNode
    implements SequentialProcess
{
    private static final String ID = "id";
    private static final String LET = ASTKeyBinding.LET_KW;
    
    private static int DEFAULT_BUF_SIZE = 50;
    
    /** Holds value of property declaration. */
    private Instruction declaration;
    
    /** Holds value of property self. */
    private Data self;
    
    /** Holds value of property uniqueIds. */
    private Set uniqueIds;
    
    private List declList;
    
    /** Holds value of property statistics. */
    private int statistics = 0;
    
    /** Holds value of property symbolTable. */
    private Map symbolTable;
    
    /** Holds value of property keyTable. */
    private Map keyTable;
    
    public ASTSequentialProcessDef(int id) {
        super(id);
    }
    
    public ASTSequentialProcessDef(RoSpi p, int id) {
        super(p, id);
    }
    
    public String toString()
    {
        StringBuffer res = new StringBuffer(DEFAULT_BUF_SIZE);
        res.
            append(this.getSelf()).
            append(" > ").
            append(declaration.getName()).
            append("(");
        
        Data[] data = declaration.getData();
        int size = data.length;
        if (size > 0)
        {
            res.append(data[0]);
            for (int i = 1; i < size; ++i)
            {
                Data d = data[i];
                if (d instanceof TaggedData) res.append(", ").append(d);
                else
                {
                    KeyData kd = (KeyData)d;
                    String kImg = kd.toString();
                    res.append(", ").append(kImg.replaceAll(" = ", ":")); 
                }
            }
        }
        
        res.append(") :=\n");
        return res.toString();
    }
    
    public boolean equals(Object obj)
    {
        if (obj == null || !(obj instanceof ASTSequentialProcessDef))
            return false;
        
        ASTSequentialProcessDef compared = (ASTSequentialProcessDef)obj;
        String s1 = this.toString();
        String s2 = compared.toString();
        return s1.equals(s2);
    }
    
    private void scanDeclaration()
    {
        declList = new LinkedList();
        uniqueIds = new HashSet();

        Data self = this.getSelf();
        uniqueIds.add(self.getInfo());
        declList.add(self);

        Data[] args = this.getDeclaration().getData();
        int size = args.length;
        for (int i = 0; i < size; ++i)
        {
            Data data = args[i];
            if (data instanceof TaggedData)
            {
                String info = data.getInfo();
                data = new SimpleData(info);
                uniqueIds.add(info);
            }
            declList.add(data);
        }
    }
    
    public Instruction getInstruction() { return declaration; }
    
    public final Instruction getDeclaration(Data arg)
    {
        String name = arg instanceof KeyData ? LET : ID;
        return new InstructionImpl(name, new Data[]{ arg });
    }
    
    /** Getter for property declaration.
     * @return Value of property declaration.
     *
     */
    public Instruction getDeclaration() {
        return this.declaration;
    }
    
    /** Setter for property declaration.
     * @param declaration New value of property declaration.
     *
     */
    public void setDeclaration(Instruction declaration) {
        this.declaration = declaration;
        this.scanDeclaration();
    }
    
    public final CloneableIterator instrIterator()
    {
        return this.getNodeIteratorInstance(this, ASTInstruction.class);
    }
    
    /** Getter for property self.
     * @return Value of property self.
     *
     */
    public Data getSelf() {
        return this.self;
    }
    
    /** Setter for property self.
     * @param self New value of property self.
     *
     */
    public void setSelf(Data self) {
        this.self = self;
    }
    
    public final Iterator declIterator() { return declList.iterator(); }
    
    /** Getter for property uniqueIds.
     * @return Value of property uniqueIds.
     *
     */
    public Set getUniqueIds() {
        return this.uniqueIds;
    }
    
    /** Getter for property protocol.
     * @return Value of property protocol.
     *
     */
    public Protocol getProtocol() {
        return (Protocol)this.jjtGetParent();
    }
    
    /** Getter for property statistics.
     * @return Value of property statistics.
     *
     */
    public int getStatistics() {
        return this.statistics;
    }
    
    /** Setter for property statistics.
     * @param statistics New value of property statistics.
     *
     */
    public void setStatistics(int statistics) {
        this.statistics = statistics;
    }
    
    /** Getter for property symbolTable.
     * @return Value of property symbolTable.
     *
     */
    public Map getSymbolTable() {
        return this.symbolTable;
    }
    
    /** Setter for property symbolTable.
     * @param symbolTable New value of property symbolTable.
     *
     */
    void setSymbolTable(Map symbolTable) {
        this.symbolTable = symbolTable;
    }
    
    /** Getter for property keyTable.
     * @return Value of property keyTable.
     *
     */
    Map getKeyTable() {
        return this.keyTable;
    }
    
    /** Setter for property keyTable.
     * @param keyTable New value of property keyTable.
     *
     */
    public void setKeyTable(Map keyTable) {
        this.keyTable = keyTable;
    }
    
}
