/* Generated By:JJTree&JavaCC: Do not edit this line. RoSpi.java */
package it.unive.dsi.pear.core.parser.rospi;

import java.util.*;
import java.io.*;

import it.unive.dsi.pear.core.parser.*;

public class RoSpi extends JJCParser/*@bgen(jjtree)*/implements RoSpiTreeConstants, RoSpiConstants {/*@bgen(jjtree)*/
  protected static JJTRoSpiState jjtree = new JJTRoSpiState();
    public static final int PRINCIPAL_NUMBER = 2;

    private static final ASTInstruction[] INSTRUCTION_ARRAY = {};

    private static final String PRINCIPAL_TAG = "Id";
    private static final String RUNNING_PRINCIPAL_TAG = "Self";

    private static final EnumType[] PRINCIPAL_TYPES =
    {
        RoSpiType.PRINCIPAL,
        RoSpiType.RUNNING_PRINCIPAL
    };

    private static final EnumType[] KEY_TYPES =
    {
        RoSpiType.KEY,
        RoSpiType.VARIABLE
    };

    private static final EnumType[] ASYM_KEY_TYPES =
    {
        RoSpiType.ASYM_KEY,
        RoSpiType.VARIABLE
    };

    private static final EnumType[] MESSAGE_TYPES =
    {
        RoSpiType.NAME,
        RoSpiType.VARIABLE
    };


    private final Map keyTable = new HashMap();
    private final Map instrIdMap = new HashMap();
    private final Set spInstrIds = new HashSet();

    private final SemanticException WRONG_COUPLING =
        new SemanticException(Errors.WRONG_COUPLING);

    // -------------------------------------------------------- Methods

        private final Data data()
                throws ParseException
        {
                return this.data(false);
        }

        private void checkArg(Data arg, String id, String self, Map substMap)
        {
                if (arg instanceof TaggedData)
                {
                        this.checkType(id, RoSpiType.PRINCIPAL);
                        substMap.put(arg.getInfo(), id);
                }
                else if (arg instanceof KeyData)
                {
                        this.checkType(id, RoSpiType.KEY);

                        KeyData key = (KeyData)this.keyTable.get(id);
            if (key == null) this.throwException(new SemanticException(
                Errors.getMsg(Errors.UNDECLARED_KEY, id)));

                        KeyData argKey = (KeyData)arg;
            String declSelf = (String)substMap.get(RUNNING_PRINCIPAL_TAG);
            if (!argKey.appliesTo(key, substMap, declSelf, self))
                this.throwException(new SemanticException(
                        Errors.getMsg(Errors.WRONG_KEY_DECL, "" + key)));
                }
        }


    private void setInstrId(String instrId, ASTInstruction instrNode)
    {
        Instruction instr = instrNode.getInstruction();
        if (spInstrIds.contains(instrId) || !(instr instanceof CipherInstruction))
        {
            this.throwException(WRONG_COUPLING);
            return;
        }

        spInstrIds.add(instrId);
        List idList = (List)instrIdMap.get(instrId);
        int size = 0;

        if (idList == null)
            instrIdMap.put(instrId, idList = new ArrayList(PRINCIPAL_NUMBER));
        else if ((size = idList.size()) >= PRINCIPAL_NUMBER)
        {
            this.throwException(WRONG_COUPLING);
            return;
        }
        else if (size > 0)
        {
            ASTInstruction ai = (ASTInstruction)idList.get(0);
            CipherInstruction i = (CipherInstruction)ai.getInstruction();
            if (!i.isCompatible((CipherInstruction)instr))
            {
                this.throwException(WRONG_COUPLING);
                return;
            }
        }


        idList.add(instrNode);
    }

    private Map getInstrIdMap()
    {
        Map res = new HashMap();

        Iterator it = instrIdMap.entrySet().iterator();
        while (it.hasNext())
        {
            Map.Entry me = (Map.Entry)it.next();
            List idList = (List)me.getValue();
            if (idList.size() == PRINCIPAL_NUMBER) res.put(me.getKey(), idList);
        }

        return res;
    }

    public SymbolTable getSymbolTableInstance()
        { return new DefaultSymbolTable(RoSpiType.VALUES); }

    public GenericToken getCurrentToken() { return this.getToken(0); }

    public javax.swing.tree.TreeNode getParseTree() throws ParseException
        { return this.protocolNarration(); }

    public static void main(String[] args)
        throws ParseException, SemanticException
    {
        InputStream is;
        try { is = args.length > 0 ? new FileInputStream(args[0]) : System.in; }
        catch (Exception e)
        {
            e.printStackTrace();
            is = System.in;
        }

        RoSpi parser = new RoSpi(is);

        try
        {
            ASTProtocolNarration pn = parser.protocolNarration();

            System.out.println("\nassociatedRules: " + pn.getAssociatedRules());
            System.out.println("\ndescription: " + pn.getDescription());

            System.out.println();
            pn.dump("");

            System.out.println("\ninstrIdMap:");
            Iterator it = pn.getInstrIdMap().entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry me = (Map.Entry)it.next();
                System.out.println(me.getKey() + "=" + me.getValue());
            }
        }
        catch (SemanticException se)
        {
            Token tok = parser.getToken(0);
            System.out.println("semantic exception at (" +
                               tok.beginLine + ", " + tok.beginColumn + "):");
            se.printStackTrace();
        }
    }

// root non terminal
  final public ASTProtocolNarration protocolNarration() throws ParseException, SemanticException {
 /*@bgen(jjtree) ProtocolNarration */
    ASTProtocolNarration jjtn000 = new ASTProtocolNarration(JJTPROTOCOLNARRATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);String protocolName;
    HashMap processDecls = new HashMap();
    Map declTable = new HashMap();
    Collection rules = null;
    String desc = null;
    CompositeData decl;
    try {
                symbolTable.clear();
                keyTable.clear();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RULES_KW:
        rules = associatedRules();
        break;
      default:
        jj_la1[0] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DESC_KW:
        desc = description();
        break;
      default:
        jj_la1[1] = jj_gen;
        ;
      }
      jj_consume_token(PROTOCOL_KW);
      protocolName = identifier();
      jj_consume_token(COLON);
      label_1:
      while (true) {
        decl = sequentialProcessDef(declTable);
      processDecls.put(decl.getContent()[0].getInfo(), decl);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[2] = jj_gen;
          break label_1;
        }
      }
      jj_consume_token(START_KW);
      jj_consume_token(DOT);
      processesInst(processDecls);
      jj_consume_token(0);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        jjtn000.setAssociatedRules(rules);
        jjtn000.setDescription(desc);
        jjtn000.setProtocolName(protocolName);
        jjtn000.setInstrIdMap(this.getInstrIdMap());

        {if (true) return jjtn000;}
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          if (jjte000 instanceof SemanticException) {
            {if (true) throw (SemanticException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
    throw new Error("Missing return statement in function");
  }

  final public Collection associatedRules() throws ParseException {
    List rules = new LinkedList();
    Token t;
    String s;
    jj_consume_token(RULES_KW);
    jj_consume_token(COLON);
    t = jj_consume_token(RULES_NAME);
        s = t.image;
        rules.add(s.substring(1, s.length() - 1));
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_2;
      }
      jj_consume_token(COMMA);
      t = jj_consume_token(RULES_NAME);
        s = t.image;
        rules.add(s.substring(1, s.length() - 1));
    }
      {if (true) return new HashSet(rules);}
    throw new Error("Missing return statement in function");
  }

  final public String description() throws ParseException {
    List rules = new LinkedList();
    Token t;
    jj_consume_token(DESC_KW);
    t = jj_consume_token(DESC_TEXT);
        String s = t.image;
        s = s.substring(1, s.length() - 1);
        {if (true) return s.replaceAll("\r", "");}
    throw new Error("Missing return statement in function");
  }

// sequential processes definition
  final public CompositeData sequentialProcessDef(Map declTable) throws ParseException, SemanticException {
 /*@bgen(jjtree) SequentialProcessDef */
    ASTSequentialProcessDef jjtn000 = new ASTSequentialProcessDef(JJTSEQUENTIALPROCESSDEF);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);CompositeData decl;
    try {
      symbolTable.clear();
      decl = sequentialProcessHeader();
      jj_consume_token(SP_ASSIGN);
      sequentialProcess();
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
                jjtn000.setSelf(new SimpleData(decl.getInfo()));
                jjtn000.setDeclaration((Instruction)decl.getContent()[0]);
        jjtn000.setSymbolTable(new HashMap(symbolTable));

        declTable.putAll(symbolTable);

        log.debug("sequentialProcessDef (st): ", symbolTable.entrySet());
        {if (true) return decl;}
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      if (jjte000 instanceof SemanticException) {
        {if (true) throw (SemanticException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public CompositeData sequentialProcessHeader() throws ParseException, SemanticException {
    String id = null;
    String self = null;
    String proc = null;
    Token t = null;
    self = identifier();
      this.put(token, RoSpiType.RUNNING_PRINCIPAL);
    jj_consume_token(SEQ_PROC_ASSIGN);
    proc = identifier();
      this.put(token, RoSpiType.SEQUENTIAL_PROCESS);
    jj_consume_token(LPAR);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id = identifier();
      jj_consume_token(COLON);
      seqProcHeaderTag(id);
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[4] = jj_gen;
          break label_3;
        }
        jj_consume_token(COMMA);
        id = identifier();
        jj_consume_token(COLON);
        seqProcHeaderTag(id);
      }
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
    jj_consume_token(RPAR);
        CompositeData cd = new CompositeData(self, null);
        cd.setContent(new Data[]{ new InstructionImpl(proc, symbolTable.getSymbolList()) });
        {if (true) return cd;}
    throw new Error("Missing return statement in function");
  }

  final public void seqProcHeaderTag(String p) throws ParseException {
        KeyData kd = null;
    Token t = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID_KW:
      t = jj_consume_token(ID_KW);
        this.putListElement(new TaggedDataImpl(p, t.image), RoSpiType.PRINCIPAL);

        if (false) this.throwException(
            new SemanticException(Errors.getMsg(Errors.DUPLICATE_PRINCIPAL, p), t));
      break;
    case SYM_KEY_KW:
    case ASYM_KEY_KW:
      kd = keyInstr(p);
        if (kd instanceof AsymKeyData) this.putListElement(kd, RoSpiType.ASYM_KEY);
        else this.putListElement(kd, RoSpiType.KEY);
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public KeyData keyInstr(String p) throws ParseException {
    String p1, p2;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SYM_KEY_KW:
      jj_consume_token(SYM_KEY_KW);
      jj_consume_token(LPAR);
      p1 = identifier();
      jj_consume_token(COMMA);
      p2 = identifier();
        if (p1.equals(p2)) this.throwException(
            new SemanticException(Errors.getMsg(Errors.DUPLICATE_PRINCIPAL, p2), token));
      jj_consume_token(RPAR);
        SimpleData[] kp = new SimpleData[]{ new SimpleData(p1), new SimpleData(p2) };
        {if (true) return new KeyData(p, kp);}
      break;
    case ASYM_KEY_KW:
      jj_consume_token(ASYM_KEY_KW);
      jj_consume_token(LPAR);
      p1 = identifier();
      jj_consume_token(RPAR);
      {if (true) return new AsymKeyData(p, new SimpleData[]{ new SimpleData(p1) });}
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void sequentialProcess() throws ParseException {
      spInstrIds.clear();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IN_KW:
      case OUT_KW:
      case NEW_KW:
      case DECRYPT_KW:
      case ENCRYPT_KW:
      case RUN_KW:
      case COMMIT_KW:
      case INTEGER:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_4;
      }
      instruction();
      jj_consume_token(DOT);
    }
    nil();
  }

  final public void instruction() throws ParseException {
 /*@bgen(jjtree) Instruction */
    ASTInstruction jjtn000 = new ASTInstruction(JJTINSTRUCTION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Instruction instr;
    Token t = null;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER:
      case IDENTIFIER:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          t = jj_consume_token(IDENTIFIER);
          break;
        case INTEGER:
          t = jj_consume_token(INTEGER);
          break;
        default:
          jj_la1[9] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jj_consume_token(COLON);
        break;
      default:
        jj_la1[10] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IN_KW:
        instr = input();
        break;
      case OUT_KW:
        instr = output();
        break;
      case NEW_KW:
        instr = restriction();
        break;
      case DECRYPT_KW:
        instr = decryption();
        break;
      case ENCRYPT_KW:
        instr = encryption();
        break;
      case RUN_KW:
        instr = run();
        break;
      case COMMIT_KW:
        instr = commit();
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        jjtn000.setInstruction(instr);

        if (t != null)
        {
            warnToken = t;
            String instrId = t.image;
            this.setInstrId(instrId, jjtn000);
            warnToken = null;
            jjtn000.setInstrId(instrId);
        }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void nil() throws ParseException {
 /*@bgen(jjtree) Instruction */
    ASTInstruction jjtn000 = new ASTInstruction(JJTINSTRUCTION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(NIL_KW);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
      jjtn000.setInstruction(new InstructionImpl(tok.image, null));
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public Instruction input() throws ParseException {
    Token t = null;
    Data[] data = null;
    t = jj_consume_token(IN_KW);
    data = dataList(false);
        int size = data.length;
        for (int i = 0; i < size; i++)
        {
                Data d = data[i];
                if (symbolTable.get(d) == null) this.put(d, RoSpiType.VARIABLE);
                }

        {if (true) return new InstructionImpl(t.image, data);}
    throw new Error("Missing return statement in function");
  }

  final public Instruction output() throws ParseException {
    Token t = null;
    Data[] data = null;
    t = jj_consume_token(OUT_KW);
    data = dataList(true);
/*
        int size = data.length;
        for (int i = 0; i < size; i++)
            this.checkDeclaration(symbolTable, data[i].getInfo());
*/

        {if (true) return new InstructionImpl(t.image, data);}
    throw new Error("Missing return statement in function");
  }

  final public Instruction restriction() throws ParseException {
    Token t = null;
    String id = null;
    Data d;
    t = jj_consume_token(NEW_KW);
    jj_consume_token(LPAR);
    id = identifier();
    d = taggedData(id);
    jj_consume_token(RPAR);
        this.put(id, RoSpiType.NAME);
        {if (true) return new InstructionImpl(t.image, new Data[]{ d });}
    throw new Error("Missing return statement in function");
  }

  final public Instruction decryption() throws ParseException {
    Token t =  null;
    CompositeData cd = null;
    Data data = null;
    t = jj_consume_token(DECRYPT_KW);
    data = data();
    jj_consume_token(AS_KW);
    cd = compositeData(data, true);
        this.checkType(symbolTable, data.getInfo(), RoSpiType.VARIABLE);
        {if (true) return new Decrypt(cd);}
    throw new Error("Missing return statement in function");
  }

  final public Instruction encryption() throws ParseException {
    Token t = null;
    CompositeData cd = null;
    String id = null;
    t = jj_consume_token(ENCRYPT_KW);
    cd = compositeData(null, true);
    jj_consume_token(AS_KW);
    id = identifier();
        this.put(id, RoSpiType.VARIABLE);
        cd.setInfo(id);
        {if (true) return new Encrypt(cd);}
    throw new Error("Missing return statement in function");
  }

  final public Instruction run() throws ParseException {
    Token t = null;
    Data[] pc;
    t = jj_consume_token(RUN_KW);
    pc = principalCouple();
      {if (true) return new InstructionImpl(t.image, pc);}
    throw new Error("Missing return statement in function");
  }

  final public Data[] principalCouple() throws ParseException {
    String p1 = null;
    String p2 = null;
    Data[] msg = null;
    jj_consume_token(LPAR);
    p1 = identifier();
                               this.checkType(p1, PRINCIPAL_TYPES);
    jj_consume_token(COMMA);
    p2 = identifier();
                                this.checkType(p2, PRINCIPAL_TYPES);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      msg = dataSeq(false);
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
    jj_consume_token(RPAR);
        Data[] principals = { new SimpleData(p1), new SimpleData(p2) };
        if (msg == null) {if (true) return principals;}

        List res = new ArrayList(Arrays.asList(principals));
        res.addAll(Arrays.asList(msg));

        {if (true) return (Data[])res.toArray(new Data[res.size()]);}
    throw new Error("Missing return statement in function");
  }

  final public Instruction commit() throws ParseException {
    Token t = null;
    Data[] pc;
    t = jj_consume_token(COMMIT_KW);
    pc = principalCouple();
      {if (true) return new InstructionImpl(t.image, pc);}
    throw new Error("Missing return statement in function");
  }

  final public Data[] dataList(boolean check) throws ParseException {
    Data[] data = null;
    jj_consume_token(LPAR);
    data = dataSeq(!check);
    jj_consume_token(RPAR);
      {if (true) return data;}
    throw new Error("Missing return statement in function");
  }

  final public Data[] dataSeq(boolean addDecl) throws ParseException {
    List list = new LinkedList();
    Data data = null;
    data = data(addDecl);
                           list.add(data);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[13] = jj_gen;
        break label_5;
      }
      jj_consume_token(COMMA);
      data = data(addDecl);
                                    list.add(data);
    }
      {if (true) return (Data[])list.toArray(Data.EMPTY_DATA);}
    throw new Error("Missing return statement in function");
  }

  final public CompositeData compositeData(Data d, boolean addDecl) throws ParseException {
    List list = new LinkedList();
    String key = null;
    SimpleData kd = null;
    boolean pub = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      jj_consume_token(LBRACE);
      compositeDataElement(list, addDecl);
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[14] = jj_gen;
          break label_6;
        }
        jj_consume_token(COMMA);
        compositeDataElement(list, addDecl);
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KEY_SEP:
        jj_consume_token(KEY_SEP);
        key = identifier();
                                    this.checkType(key, KEY_TYPES);
                                                                        kd = new SimpleData(key);
        break;
      default:
        jj_la1[15] = jj_gen;
        ;
      }
      break;
    case ASYM_LBRACE:
      jj_consume_token(ASYM_LBRACE);
      compositeDataElement(list, addDecl);
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[16] = jj_gen;
          break label_7;
        }
        jj_consume_token(COMMA);
        compositeDataElement(list, addDecl);
      }
      jj_consume_token(ASYM_RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KEY_SEP:
        jj_consume_token(KEY_SEP);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PUB_KW:
          jj_consume_token(PUB_KW);
                           pub = true;
          break;
        case PRIV_KW:
          jj_consume_token(PRIV_KW);
          break;
        default:
          jj_la1[17] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jj_consume_token(LPAR);
        key = identifier();
                                 this.checkType(key, ASYM_KEY_TYPES);
        jj_consume_token(RPAR);
        break;
      default:
        jj_la1[18] = jj_gen;
        ;
      }
      kd = new AsymKeyData.KeyInstance(key, pub);
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        CompositeData cd = new CompositeData(this.getTaggedContent());
        if (d != null) cd.setInfo(d.getInfo());
        cd.setContent((Data[])list.toArray(Data.EMPTY_DATA));
        cd.setKey(kd);
        {if (true) return cd;}
    throw new Error("Missing return statement in function");
  }

  final public void compositeDataElement(List list, boolean addDecl) throws ParseException {
    String info = null;
    Data data = null;
    data = data(addDecl);
        info = data.getInfo();
        if (info != null)
        {
            if (addDecl && symbolTable.get(info) == null)
                symbolTable.put(info, RoSpiType.VARIABLE);
            this.checkDeclaration(symbolTable, info);
        }
        list.add(data);
  }

  final public Data data(boolean addDecl) throws ParseException {
    Data d;
    String id = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id = identifier();
      d = taggedData(id);
      break;
    case LBRACE:
      d = multiTaggedData(addDecl);
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        if (id != null)
        {
            if (addDecl)
                { if (symbolTable.get(id) == null) symbolTable.put(id, RoSpiType.VARIABLE); }
            else
                this.checkDeclaration(symbolTable, id);
        }

        {if (true) return d;}
    throw new Error("Missing return statement in function");
  }

  final public Data taggedData(String id) throws ParseException {
    String t = null;
    Data[] params = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      t = identifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAR:
        params = dataList(true);
        break;
      default:
        jj_la1[21] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[22] = jj_gen;
      ;
    }
        if (t != null)
            if (params == null) {if (true) return new TaggedDataImpl(id, t);}
            else {if (true) return new ParametricTaggedDataImpl(id, t, params);}
        else
            {if (true) return new SimpleData(id);}
    throw new Error("Missing return statement in function");
  }

  final public Data multiTaggedData(boolean addDecl) throws ParseException {
    String t = null;
    Data[] multi = null;
    Data[] params = null;
    jj_consume_token(LBRACE);
    multi = dataSeq(addDecl);
    jj_consume_token(RBRACE);
    jj_consume_token(COLON);
    t = identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAR:
      params = dataList(true);
      break;
    default:
      jj_la1[23] = jj_gen;
      ;
    }
        MultiTaggedDataImpl mtd = new MultiTaggedDataImpl(multi, t);
        mtd.setParameters(params);
        {if (true) return mtd;}
    throw new Error("Missing return statement in function");
  }

  final public String identifier() throws ParseException {
    Token t;
    t = jj_consume_token(IDENTIFIER);
                       {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// processes instantiation and key binding
  final public void processesInst(HashMap processDecls) throws ParseException, SemanticException {
      symbolTable.clear();
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LET_KW:
        ;
        break;
      default:
        jj_la1[24] = jj_gen;
        break label_8;
      }
      keyBinding();
      jj_consume_token(DOT);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAR:
      jj_consume_token(LPAR);
      sequentialProcessInst(processDecls);
      label_9:
      while (true) {
        jj_consume_token(PIPE);
        sequentialProcessInst(processDecls);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PIPE:
          ;
          break;
        default:
          jj_la1[25] = jj_gen;
          break label_9;
        }
      }
      jj_consume_token(RPAR);
      break;
    default:
      jj_la1[26] = jj_gen;
      ;
    }
  }

  final public void keyBinding() throws ParseException {
 /*@bgen(jjtree) KeyBinding */
    ASTKeyBinding jjtn000 = new ASTKeyBinding(JJTKEYBINDING);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);String k = null;
    KeyData key = null;
    Data[] kp = null;
    try {
      jj_consume_token(LET_KW);
      k = identifier();
      jj_consume_token(ASSIGN);
      key = keyInstr(k);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        jjtn000.setKey(key);
        this.keyTable.put(k, key);
        kp = key.getPrincipals();

        this.put(new SimpleData(k), RoSpiType.KEY);
        int size = kp.length;
        for (int i = 0; i < size; ++i)
        {
                Data kpi = kp[i];
                if (symbolTable.get(kpi) == null) this.put(kpi, RoSpiType.PRINCIPAL);
                }

                log.debug("sequentialProcessInst (symbolTable): ", symbolTable.entrySet());
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void sequentialProcessInst(HashMap decls) throws ParseException, SemanticException {
 /*@bgen(jjtree) SequentialProcessInst */
    ASTSequentialProcessInst jjtn000 = new ASTSequentialProcessInst(JJTSEQUENTIALPROCESSINST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Map substMap = new HashMap();
    List argList = new LinkedList();
    String id = null;
    String seqProc = null;
    String self = null;
    CompositeData cd = null;
    Instruction decl = null;
        Data args[] = null;
    Token t = null;
    int argNumber = 0;
    int i = 0;
    try {
      self = identifier();
                              this.checkType(self, RoSpiType.PRINCIPAL);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEQ_PROC_ASSIGN:
        t = jj_consume_token(SEQ_PROC_ASSIGN);
        break;
      case REPL_SEQ_PROC_ASSIGN:
        t = jj_consume_token(REPL_SEQ_PROC_ASSIGN);
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jjtn000.setReplicated(t.image.length() > 1);
      // sequential_process
          id = identifier();
        seqProc = id;
                cd = (CompositeData)decls.get(id);
        if (cd == null) this.throwException(
            new SemanticException(Errors.getMsg(Errors.UNDECLARED_SEQ_PROCESS, id), token));
        else
        {
                decl = (Instruction)cd.getContent()[0];
            args = decl.getData();
            argNumber = args.length;
            String declSelf = cd.getInfo();
            substMap.put(RUNNING_PRINCIPAL_TAG, declSelf);
                substMap.put(declSelf, self);
        }
      jj_consume_token(LPAR);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        id = identifier();
        if (0 < argNumber && args != null) this.checkArg(args[0], id, self, substMap);
        argList.add(new SimpleData(id));
        label_10:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[28] = jj_gen;
            break label_10;
          }
          jj_consume_token(COMMA);
          id = identifier();
        if (++i < argNumber && args != null) this.checkArg(args[i], id, self, substMap);
        argList.add(new SimpleData(id));
        }
          ++i;
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
      jj_consume_token(RPAR);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        if (decl != null && i != argNumber)
            this.throwException(new SemanticException(
                Errors.getMsg(Errors.WRONG_ARG_NUMBER, "" + i, "" + argNumber), token));

        args = (Data[])argList.toArray(Data.EMPTY_DATA);
        jjtn000.setSequentialProcessDecl(new InstructionImpl(seqProc, args));

        jjtn000.setAssignedPrincipal(new SimpleData(self));
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

  public RoSpiTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[30];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x800600,0x600,0x1de000,0x0,0x0,0x1de000,0x0,0x0,0x0,0x0,0x0,0x600000,0x0,0x50000000,0x10000000,0x4000000,0x0,0x4000000,0x100,0x0,0x4000000,0x3000000,0x0,0x0,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x200,0x800,0x100,0x4,0x4,0x100,0x0,0x0,0x180,0x180,0x180,0x0,0x4,0x4,0x4,0x40,0x4,0x0,0x40,0x0,0x100,0x0,0x2,0x0,0x0,0x8,0x0,0x0,0x4,0x100,};
   }

  public RoSpi(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new RoSpiTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 30; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 30; i++) jj_la1[i] = -1;
  }

  public RoSpi(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new RoSpiTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 30; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 30; i++) jj_la1[i] = -1;
  }

  public RoSpi(RoSpiTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 30; i++) jj_la1[i] = -1;
  }

  public void ReInit(RoSpiTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 30; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[45];
    for (int i = 0; i < 45; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 30; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 45; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
