/*
 * RoSpiNode.java
 *
 * Created on 18 gennaio 2004, 22.56
 */

package it.unive.dsi.pear.core.parser.rospi;

import java.util.*;

import it.unive.dsi.pear.core.parser.*;

/** This class is a straightforward implementation of
 * <CODE>ProtocolNode</CODE>.
 */
abstract public class RoSpiNode extends SimpleNode
    implements ProtocolNode
{
    protected static final String STRINGDUMP_PREFIX = "";
    
    private Object decoration = null;
    
    protected RoSpi parser;
    
    public RoSpiNode(int i) { super(i); }
    public RoSpiNode(RoSpi p, int i)
    {
        this(i);
        parser = p;
    }
    
    abstract public Instruction getInstruction();
    public String toString() { return RoSpiTreeConstants.jjtNodeName[id]; }
    public String toString(String prefix) { return prefix + toString(); }
    
    public boolean equals(Object obj)
    {
        if (obj == null || !(obj instanceof RoSpiNode)) return false;
        
        RoSpiNode compared = (RoSpiNode)obj;
        String s1 = this.stringDump(STRINGDUMP_PREFIX);
        String s2 = compared.stringDump(STRINGDUMP_PREFIX);        
        return s1.equals(s2);
    }

    public String getSeparator()
    {
        Instruction instr = this.getInstruction();
        String name = instr.getName();
        boolean voidInstr = instr.isNil();
        return voidInstr ? "\n" : Instruction.SEPARATOR;
    }
    
    /** Getter for property rule.
     * @return Value of property rule.
     *
     */
    public Object getDecoration() {
        return decoration;
    }
    
    /** Setter for property rule. */
    public void setDecoration(Object decoration) {
        this.decoration = decoration;
    }
    
    /** Getter for property instructionNode.
     * @return Value of property instructionNode.
     */
    public boolean isInstructionNode() {
        return this instanceof ASTInstruction;
    }
    
}

