/*
 * contentEquals.java
 *
 * Created on 1 aprile 2004, 15.12
 */

package it.unive.dsi.pear.plugins;

import java.util.*;

import it.unive.dsi.pear.core.parser.Ciphertext;
import it.unive.dsi.pear.core.parser.Container;
import it.unive.dsi.pear.core.parser.Data;
import it.unive.dsi.pear.core.parser.Instruction;
import it.unive.dsi.pear.core.DefaultOperation;

/**
 * This operation checks that the given argument content doesn't match the
 * container one.
 * @author  Francesco Placella
 */
public class contentEquals extends DefaultOperation
{
    private static final Container.OperationException WRONG_ARG_NUM =
        new Container.OperationException("wrong argument number");
    
    public Object perform(Container container, Container[] args)
        throws Container.OperationException
    {
        if (args.length != 2) throw WRONG_ARG_NUM;
        
        Container cont = (Container)args[0];
        Ciphertext cd = (Ciphertext)cont.get((Data)container);
        Ciphertext acd = (Ciphertext)cont.get(((Data)args[1]));
        
        List cl = (List)cd.content();
        List acl = (List)acd.content();
        Instruction instr = (Instruction)cd.getContent()[0];
        Instruction aInstr = (Instruction)acd.getContent()[0];
        cd = (Ciphertext)instr.getData()[0];
        acd = (Ciphertext)aInstr.getData()[0];
        
        boolean res = cd.content().equals(acd.content());
        
        return new Boolean(res);
    }
}
