/*
 * addEach.java
 *
 * Created on 22 giugno 2004, 15.43
 */

package it.unive.dsi.pear.plugins;

import it.unive.dsi.pear.core.parser.Container;
import it.unive.dsi.pear.core.parser.Data;
import it.unive.dsi.pear.core.parser.Instruction;
import it.unive.dsi.pear.core.DefaultOperation;

/**
 * This operation adds to the given container each argument including it as
 * argument of the given instruction if any.
 * @author  Francesco Placella
 */
public class addEach extends DefaultOperation
{
    public Object perform(Container container, Container[] args)
        throws Container.OperationException
    {
        try
        {
            boolean res = true;
            
            if (args.length > 0)
            {
                boolean addOn = args[0] instanceof Instruction;
                Instruction instr = addOn ? (Instruction)args[0] : null;

                int size = args.length;
                for (int i = addOn ? 1 : 0; i < size; ++i)
                {
                    Data data = (Data)args[i];
                    if (addOn)
                    {
                        Instruction di = (Instruction)instr.clone();
                        di.setData(new Data[]{ data });
                        data = di;
                    }
                    res = res && this.add(container, data);
                }
            }

            return new Boolean(res);
        }
        catch (Exception ex) { throw new Container.OperationException(ex); }
    }
    
    protected boolean add(Container container, Data data)
        throws Container.OperationException
    {
        return container.add(data);
    }
}
