/*
 * checkWellFormedness.java
 *
 * Created on 16 giugno 2004, 17.41
 */

package it.unive.dsi.pear.plugins;

import java.util.*;

import it.unive.dsi.pear.core.parser.Container;
import it.unive.dsi.pear.core.parser.Data;
import it.unive.dsi.pear.core.parser.Instruction;
import it.unive.dsi.pear.core.DefaultOperation;

/**
 * This operation performs a well-formedness check on the given container
 * @author  Francesco Placella
 */
public class checkWellFormedness extends DefaultOperation
{
    public Object perform(Container container, Container[] args)
        throws Container.OperationException
    {
        try
        {
            Data data = (Data)args[0];
            Data type = (Data)args[1];
            return new Boolean(this.perform(container, data, type));
        }
        catch (Exception ex) { throw new Container.OperationException(ex); }
    }
    
    static boolean perform(Container container, Data data, Data type)
    {
        // ENV 0
        if (container.content().isEmpty()) return true;
        
        // ENV NAME AND VAR
        return envNameAndVar(container, data, type);
    }
    
    private static 
        boolean envNameAndVar(Container container, Data data, Data type)
    {
        if (type instanceof Instruction)
        {
            Data[] terms = ((Instruction)type).getData();
            
            Data term;
            int size = terms.length;
            for (int i = 0; i < size; ++i)
                if (data.equals(term = terms[i]) ||
                    !checkType.perform(container, term, checkType.UNTRUSTED))
                    return false;
        }
        
        return true;
    }
}
