/*
 * ArrayIterator.java
 *
 * Created on 19 marzo 2004, 18.57
 */

package it.unive.dsi.pear.util;

import java.util.*;

/** This class provides a way to iterate over the elements of a given array.
 * @author Francesco Placella
 */
public class ArrayIterator extends CloneableIterator
{
    private Object[] objArray;
    private int index = 0;
    
    /** Creates a new instance of ArrayIterator.
     * @param objArray the array containing the elements to be iterated over
     */
    public ArrayIterator(Object[] objArray) { this.objArray = objArray; }
    
    public final boolean hasNext() { return index < objArray.length; }
    
    public final Object next()
    {
        if (index >= objArray.length) throw new NoSuchElementException();
        return objArray[index++];
    }
    
    public void remove() { throw new UnsupportedOperationException(); }
    
    public String toString() { return String.valueOf(this.index); }
    
    public boolean equals(Object obj)
    {
        if (obj == null || !(obj instanceof ArrayIterator)) return false;

        ArrayIterator ai = (ArrayIterator)obj;

        return index == ai.index && objArray.length == ai.objArray.length;
    }
}
