/*
 * CloneableIterator.java
 *
 * Created on 21 marzo 2004, 16.20
 */

package it.unive.dsi.pear.util;

import java.util.*;

/**
 * This class it's an abstract implementation of CloneableElement and Iterator
 * granting public access to the default clone method.
 * @author  Francesco Placella
 */
public abstract class CloneableIterator
    implements CloneableElement, Iterator
{
    public Object clone()
    {
        try { return super.clone(); }
        catch (CloneNotSupportedException cnse)
        {
            cnse.printStackTrace();
            return null;
        }
    }
}
