/*
 * CloneableList.java
 *
 * Created on 26 marzo 2004, 15.34
 */

package it.unive.dsi.pear.util;

import java.util.*;

/**
 * This class implements a List providing a non-shallow clone method
 * @author  Francesco Placella
 */
public class CloneableList extends java.util.LinkedList
    implements CloneableElement
{
    public static final List EMPTY_LIST = new CloneableList();
    
    public Object clone()
    {
        CloneableList cl = new CloneableList();
        
        Iterator it = this.iterator();
        while (it.hasNext())
        {
            Object val = it.next();
            if (val instanceof CloneableElement)
                val = ((CloneableElement)val).clone();
            cl.add(val);
        }
        
        return cl;
    }
}
