/*
 * ExtensionBasedFilter.java
 *
 * Created on 19 aprile 2004, 13.55
 */

package it.unive.dsi.pear.util;

import javax.swing.filechooser.*;

/**
 *
 * @author  Francesco Placella
 */
public class ExtensionBasedFileFilter extends FileFilter
    implements java.io.FileFilter
{
    private String extension;
    
    /** Creates a new instance of ExtensionBasedFilter */
    public ExtensionBasedFileFilter() { this(null); }
    public ExtensionBasedFileFilter(String extension)
    {
        this.extension = extension;
    }
    
    public boolean accept(java.io.File f)
    {
        if (f.isDirectory()) return true;
        return f.getName().endsWith("." + extension);
    }
    
    public String getDescription()
    {
        return "*." + extension + " files";
    }
    
}
