/*
 * OpNode.java
 *
 * Created on 27 febbraio 2004, 19.05
 */

package it.unive.dsi.pear.core.parser.validationrules;

import java.util.*;

import it.unive.dsi.pear.core.parser.*;

/** This class is a straightforward implementation of
 * <CODE>Operations</CODE>.
 * @author Francesco Placella
 */
public abstract class ASTOpNode extends ASTBoolNode implements Operations
{
    /** Holds value of property defSrcType. */
    private OperationSourceType defSrcType;

    /** Creates a new instance of OpNode */
    public ASTOpNode(int id) { super(id); }
    public ASTOpNode(ValidationRules p, int id) { super(p, id); }
 
    /** Getter for property defSrcType.
     * @return Value of property defSrcType.
     *
     */
    public OperationSourceType getDefSrcType() {
        return this.defSrcType;
    }
    
    /** Setter for property defSrcType.
     * @param defSrcType New value of property defSrcType.
     *
     */
    public void setDefSrcType(OperationSourceType defSrcType) {
        this.defSrcType = defSrcType;
    }
    
    public final Iterator operationIterator()
    {
        return this.descendantIterator(ASTOperation.class);    
    }

}
