/* Generated By:JJTree: Do not edit this line. ASTValidationRules.java */

package it.unive.dsi.pear.core.parser.validationrules;

import java.util.*;

import it.unive.dsi.pear.util.*;
import it.unive.dsi.pear.core.parser.*;

/** This class is a straightforward implementation of
 * <CODE>ValidationRules</CODE>.
 * @author Francesco Placella
 */
public class ASTValidationRules extends ValidationRulesNode
    implements it.unive.dsi.pear.core.parser.ValidationRules
{
    /** Holds value of property symbolTable. */
    private SymbolTable symbolTable;
    
    /** Holds value of property definedTags. */
    private String[][] definedTags;
    
    /** Holds value of property containerMap. */
    private Map containerMap;
    
    /** Holds value of property tagTypes. */
    private Map tagTypes;
    
    private int minTagNumber = -1;
    private int maxTagNumber = -1;
    
    /** Holds value of property description. */
    private String description;
    
    public ASTValidationRules(int id) {
        super(id);
    }
    
    public ASTValidationRules(ValidationRules p, int id) {
        super(p, id);
    }
    
    /* computeTagNumber computes the minimum and maximum number of tags 
     * contained in all the messages appearing in the validation rules.
     */
    private void computeTagNumber()
    {
        int min = Integer.MAX_VALUE;
        int max = Integer.MIN_VALUE;
        
        Iterator it = this.descendantIterator(ASTOperation.class);
        while (it.hasNext())
        {
            ASTOperation op = (ASTOperation)it.next();
            Data[] args = op.getArguments();
            
            int size = args.length;
            for (int i = 0; i < size; ++i)
            {
                int tagNumber = args[i].getTagNumber();
                if (tagNumber > 0)
                {
                    if (tagNumber < min) min = tagNumber;
                    if (tagNumber > max) max = tagNumber;
                }
            }
        }
        
        minTagNumber = min != Integer.MAX_VALUE ? min : 0;
        maxTagNumber = max != Integer.MIN_VALUE ? max : 0;
    }

    
    /** Getter for property symbolTable.
     * @return Value of property symbolTable.
     *
     */
    public SymbolTable getSymbolTable() {
        return this.symbolTable;
    }
    
    /** Setter for property symbolTable.
     * @param symbolTable New value of property symbolTable.
     *
     */
    public void setSymbolTable(SymbolTable symbolTable) {
        this.symbolTable = symbolTable;
    }
    
    /** Getter for property definedTags.
     * @return Value of property definedTags.
     *
     */
    public String[][] getDefinedTags() {
        return this.definedTags;
    }
    
    /** Setter for property definedTags.
     * @param definedTags New value of property definedTags.
     *
     */
    public void setDefinedTags(String[][] definedTags) {
        this.definedTags = definedTags;
    }
    
    /** Getter for property containerMap.
     * @return Value of property containerMap.
     *
     */
    public Map getContainerMap() {
        return this.containerMap;
    }
    
    /** Setter for property containerMap.
     * @param containerMap New value of property containerMap.
     *
     */
    public void setContainerMap(Map containerMap) {
        this.containerMap = containerMap;
    }
    
    /** Getter for property tagTypes.
     * @return Value of property tagTypes.
     *
     */
    public Map getTagTypes() {
        return this.tagTypes;
    }
    
    /** Setter for property tagTypes.
     * @param tagTypes New value of property tagTypes.
     *
     */
    public void setTagTypes(Map tagTypes) {
        this.tagTypes = tagTypes;
    }
    
    /** Getter for property maxTagNumber.
     * @return Value of property maxTagNumber.
     *
     */
    public int getMaxTagNumber()
    {
        if (maxTagNumber == -1) this.computeTagNumber();
        return maxTagNumber;
    }
    
    public int getMinTagNumber()
    {
        if (minTagNumber == -1) this.computeTagNumber();
        return minTagNumber;
    }
    
    public final Iterator ruleIterator() { return this.childrenIterator(); }
    
    /** Getter for property description.
     * @return Value of property description.
     *
     */
    public String getDescription() {
        return this.description;
    }
    
    /** Setter for property description.
     * @param description New value of property description.
     *
     */
    public void setDescription(String description) {
        this.description = description;
    }
    
}
