/*
 * ValidationRulesType.java
 */

package it.unive.dsi.pear.core.parser.validationrules;

import it.unive.dsi.pear.core.parser.EnumType;

/**
 *
 * @author Francesco Placella
 */
public class ValidationRulesType extends EnumType
{
    private ValidationRulesType(int typeCode) { super(typeCode); }

    public static final ValidationRulesType CONTAINER = 
        new ValidationRulesType(ValidationRulesConstants.CONTAINER_KW);

    public static final ValidationRulesType PRINCIPAL = 
        new ValidationRulesType(ValidationRulesConstants.PRINCIPAL_KW);
    
    public static final ValidationRulesType TTP = 
        new ValidationRulesType(ValidationRulesConstants.TTP_KW);
    
    public static final ValidationRulesType NAME = 
        new ValidationRulesType(ValidationRulesConstants.NAME_KW);
    
    public static final ValidationRulesType VARIABLE = 
        new ValidationRulesType(ValidationRulesConstants.VARIABLE_KW);
    
    public static final ValidationRulesType TAG = 
        new ValidationRulesType(ValidationRulesConstants.TAG_KW);
    
    public static final ValidationRulesType KEY = 
        new ValidationRulesType(ValidationRulesConstants.KEY_KW);

    public static final ValidationRulesType ANY = 
        new ValidationRulesType(ValidationRulesConstants.tokenImage.length);

    public static final ValidationRulesType[] VALUES =
    {
        CONTAINER,
        PRINCIPAL,
        TTP,
        NAME,
        VARIABLE,
        TAG,
        KEY
    };    
    
    public String toString()
    {
        int tc = super.getTypeCode();
        String[] tokimg = ValidationRulesConstants.tokenImage;
        
        if (tc < tokimg.length) return tokimg[tc];
        else return "";
    }
    
    public static ValidationRulesType getMatchingValue(int val)
    {
        int size = VALUES.length;
        for (int i = 0; i < size; ++i)
            if (VALUES[i].getTypeCode() == val) return VALUES[i];
        
        return null;
    }
}
