/*
 * XPEBoolNode.java
 *
 * Created on 13 gennaio 2005, 21.09
 */

package it.unive.dsi.pear.plugins.output.xpe;

import it.unive.dsi.pear.core.parser.AndCheck;
import it.unive.dsi.pear.core.parser.BoolNode;
import it.unive.dsi.pear.core.parser.Operation;
import it.unive.dsi.pear.core.parser.OrCheck;

import org.w3c.dom.Element;

/**
 *
 * @author Francesco Placella
 */
public final class XPEBoolNode extends XPERuleNode
{
    static final String ELEMENT = "bool";
    static final String EL_TYPE = "type";
    static final String EL_AND = "and";
    static final String EL_OR = "or";
    static final String EL_NOT = "not";
    
    
// ----------------------------------------------------------------------------

    /** Creates a new instance of XPEBoolNode */
    public XPEBoolNode(BoolNode bn, int indentLevel) { super(bn, indentLevel); }
    
    public String getElementName() { return ELEMENT; }

/*
    public Element getElement()
    {
        XPENode xn = XPEBoolNode.handleNot((BoolNode)node, this.getChildIndentLevel());
        return xn != null ? xn.getElement() : super.getElement();
    }
 */
    
    protected XPENode getXPEChild(Object child)
    {
        int cil = this.getChildIndentLevel();
        if (child instanceof Operation)
            return new XPEOperation((Operation)child, cil);
        else
            return new XPEBoolNode((BoolNode)child, cil);
    }
 
    protected void buildElement(Element e)
    {
        if (node instanceof AndCheck) e.setAttribute(EL_TYPE, EL_AND);
        else if (node instanceof OrCheck) e.setAttribute(EL_TYPE, EL_OR);
        else e.setAttribute(EL_TYPE, EL_NOT);

        super.buildElement(e);
    }
    
    private final int getChildIndentLevel() { return indentLevel + 1; }
 
    
// ----------------------------------------------------------------------------
/*
    private static XPENode handleNot(BoolNode node, int indentLevel)
    {
        if (node instanceof NotCheck)
        {
            Operation op = (Operation)node.getChildAt(0);
            return new XPEOperation(op, indentLevel, true);
        }

        return null;
    }
    
    static XPENode getXPENode(BoolNode node, int indentLevel)
    {
        XPENode xn = XPEBoolNode.handleNot(node, indentLevel);
        return xn != null ? xn : new XPEBoolNode(node, indentLevel);
    }
 */
}