/*
 * XPEConditionClause.java
 *
 * Created on 13 gennaio 2005, 20.27
 */

package it.unive.dsi.pear.plugins.output.xpe;

import it.unive.dsi.pear.core.parser.BoolNode;
import it.unive.dsi.pear.core.parser.ConditionClause;
import it.unive.dsi.pear.core.parser.Operation;

/**
 *
 * @author Francesco Placella
 */
public final class XPEConditionClause extends XPERuleNode
{
    static final int EL_INDENT = XPECondition.EL_INDENT + 1;
    static final int CL_INDENT = EL_INDENT + 1;

    /** Creates a new instance of XPEConditionClause */
    public XPEConditionClause(ConditionClause cc) { super(cc, EL_INDENT); }
    
    public String getElementName()
    {
        ConditionClause cc = (ConditionClause)node;
        return cc.getClauseName();
    }
    
    protected XPENode getXPEChild(Object child)
    {
        if (child instanceof Operation)
            return new XPEOperation((Operation)child, CL_INDENT);
        else
            return new XPEBoolNode((BoolNode)child, CL_INDENT);
//            return XPEBoolNode.getXPENode((BoolNode)child, CL_INDENT);
    }
}
