/*
 * XPEContainer.java
 *
 * Created on 13 gennaio 2005, 23.12
 */

package it.unive.dsi.pear.plugins.output.xpe;

import java.util.Collection;

import it.unive.dsi.pear.core.parser.Container;

import org.w3c.dom.Element;

/**
 *
 * @author Francesco Placella
 */
public class XPEContainer extends XPEAbstractNode
{
    // container
    static final String ELEMENT = "container";
    static final String EL_NAME = "name";
    static final int EL_INDENT = XPEInstructionNode.CN_INDENT;
    static final int DT_INDENT = EL_INDENT + 1;
    

// ----------------------------------------------------------------------------
    
    private Container container;
    
    /** Creates a new instance of XPEContainer */
    public XPEContainer(Container c) { container = c; }

    public String getElementName() { return ELEMENT; }
    
    protected void buildElement(Element e)
    {
        e.setAttribute(EL_NAME, container.getName());
        
        Collection c = container.content();
        if (!c.isEmpty())
        {
            this.appendData(e, c.iterator(), DT_INDENT);
            this.indent(e, EL_INDENT);
        }
    }
}
