/*
 * XPEInstruction.java
 *
 * Created on 9 gennaio 2005, 21.47
 */

package it.unive.dsi.pear.plugins.output.xpe;

import it.unive.dsi.pear.core.parser.Ciphertext;
import it.unive.dsi.pear.core.parser.Instruction;
import org.w3c.dom.Element;

/**
 *
 * @author Francesco Placella
 */
public class XPEInstruction extends XPEAbstractNode
{
    private static final String ELEMENT = XPEInstructionNode.INSTRUCTION;
    private static final String EL_NAME = XPEInstructionNode.IN_NAME;
    private static final String EL_RES = "identifier";

// ----------------------------------------------------------------------------
    
    private Instruction instruction;
    private String result;
    private int indentLevel;

    /** Creates a new instance of XPEInstruction */
    public XPEInstruction(Instruction in, int indentLevel)
    {
        this.indentLevel = indentLevel;
        instruction = in;
    }
    
    /** Creates a new instance of XPEInstruction */
    public XPEInstruction(Ciphertext c, int indentLevel)
    {
        this.indentLevel = indentLevel;
        result = c.getInfo();
        instruction = (Instruction)c.getContent()[0];
    }
    
    public final String getElementName() { return ELEMENT; }

    protected void buildElement(Element e)
    {
        if (result != null) e.setAttribute(EL_RES, result);
        e.setAttribute(EL_NAME, instruction.getName());
        
        this.appendData(e, instruction.getData(), indentLevel + 1);
        this.indent(e, indentLevel);
    }
}
