/*
 * XPEMultiTaggedData.java
 *
 * Created on 24 gennaio 2005, 2.06
 */

package it.unive.dsi.pear.plugins.output.xpe;

import it.unive.dsi.pear.core.parser.MultiTaggedData;

import org.w3c.dom.Element;

/**
 *
 * @author Francesco Placella
 */
public class XPEMultiTaggedData extends XPEAbstractNode
{
    private static final String ELEMENT = "tagged-identifiers";
    private static final String EL_NAME = "tag";

// ----------------------------------------------------------------------------
    
    private MultiTaggedData data;
    private int indentLevel;

    public final String getElementName() { return ELEMENT; }
    
    /** Creates a new instance of XPETaggedData */
    public XPEMultiTaggedData(MultiTaggedData mtd, int indentLevel)
    {
        data = mtd;
        this.indentLevel = indentLevel;
    }

    protected void buildElement(Element e)
    {
        e.setAttribute(EL_NAME, data.getTag());
        this.appendData(e, data.getMulti(), indentLevel + 1);
        this.indent(e, indentLevel);
    }
}
