/*
 * XPEOperation.java
 *
 * Created on 13 gennaio 2005, 18.18
 */

package it.unive.dsi.pear.plugins.output.xpe;

import it.unive.dsi.pear.core.parser.Data;
import it.unive.dsi.pear.core.parser.Operation;

import org.w3c.dom.Element;

/**
 *
 * @author Francesco Placella
 */
public final class XPEOperation extends XPERuleNode
{
    static final String ELEMENT = "operation";
    static final String EL_NAME = "name";
    static final String EL_CONTAINER = "container";
    

// ----------------------------------------------------------------------------
    
    private boolean not = false;
    
    /** Creates a new instance of XPEActions */
    public XPEOperation(Operation o, int indentLevel) { super(o, indentLevel); }
/*
    public XPEOperation(Operation o, int indentLevel, boolean not)
    {
        this(o, indentLevel);
        this.not = not;
    }
 */

    public String getElementName() { return ELEMENT; }
    
    protected final XPENode getXPEChild(Object child) { return null; }
    
    protected void buildElement(Element e)
    {
        Operation op = (Operation)node;

        e.setAttribute(EL_NAME, op.getOperationName());
        e.setAttribute(EL_CONTAINER, op.getContainerName());
//            if (not) e.setAttribute(EL_NOT, String.valueOf(not));

        Data[] args = op.getArguments();
        if (args != null && args.length > 0)
        {
            this.appendData(e, args, indentLevel + 1);
            this.indent(e, indentLevel);
        }
    }
}
