/*
 * XPEOutput.java
 *
 * Created on 1 gennaio 2005, 17.44
 */

package it.unive.dsi.pear.plugins.output.xpe;

//import it.unive.dsi.pear.core.parser.validationrules.*;
//import it.unive.dsi.pear.core.parser.*;

import it.unive.dsi.pear.core.Configuration;
import it.unive.dsi.pear.core.Validation;
import it.unive.dsi.pear.core.ValidationCore;
import it.unive.dsi.pear.core.parser.Protocol;
import it.unive.dsi.pear.core.parser.Rule;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Properties;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;


/**
 *
 * @author Francesco Placella
 */
public class XPEOutput 
    implements it.unive.dsi.pear.plugins.output.OutputPlugin
{
    public static final String DTD_NAME = "protocol-encoding.dtd";

    private static DocumentBuilder db = null;
    private static Properties elementNames = new Properties();
    
    
    static
    {
        try
        {
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
//            dbf.setValidating(true);
            dbf.setNamespaceAware(true);
            db = dbf.newDocumentBuilder();
        }
        catch (Exception ex) { ex.printStackTrace(); }
    }
    
    
    /**
     * Holds value of property protocol.
     */
    private Protocol protocol;
    
    /** Creates a new instance of XPEOutput */
    public XPEOutput() {}
    
    public Object getOutput(Protocol protocol)
    {
        this.protocol = protocol;
        Document output = db.newDocument();

        XPENode xpe = new XPEProtocol(this.getProtocol());
        xpe.setDocument(output);
        Element root = xpe.getElement();
        output.appendChild(root);

        return output;
    }
    
    /**
     * Getter for property protocol.
     * @return Value of property protocol.
     */
    public Protocol getProtocol() { return this.protocol; }
}
