/*
 * XPERuleNode.java
 *
 * Created on 13 gennaio 2005, 14.02
 */

package it.unive.dsi.pear.plugins.output.xpe;

import it.unive.dsi.pear.core.parser.TreeNode;
import java.util.Iterator;

import org.w3c.dom.Element;

/**
 *
 * @author Francesco Placella
 */
abstract public class XPERuleNode extends XPEAbstractNode
{
    protected TreeNode node;
    protected int indentLevel;
    
    protected XPERuleNode(TreeNode node, int indentLevel)
    {
        this.node = node;
        this.indentLevel = indentLevel;
    }
    
    abstract protected XPENode getXPEChild(Object child);
    
    protected void buildElement(Element e)
    {
        this.appendXPEChildren(e, node, indentLevel + 1);
    }
    
    protected void appendXPEChildren(Element parent, TreeNode tn, int indentLevel)
    {
        if (tn == null) return;
        
        Iterator it = tn.childrenIterator();
        while (it.hasNext())
        {
            XPENode xn = this.getXPEChild(it.next());
            if (xn != null) this.appendXPE(xn, parent, indentLevel);
        }

        if (tn.getChildCount() > 0) this.indent(parent, indentLevel - 1);
    }
}
