/*
 * XPEValueData.java
 *
 * Created on 9 gennaio 2005, 17.27
 */

package it.unive.dsi.pear.plugins.output.xpe;

import it.unive.dsi.pear.core.parser.ValueData;

import org.w3c.dom.Element;

/**
 *
 * @author Francesco Placella
 */
public class XPEValueData extends XPEAbstractNode
{
    private static final String ELEMENT = "valued-identifier";
    private static final String EL_NAME = "name";

// ----------------------------------------------------------------------------
    
    private ValueData data;
    private int indentLevel;

    public final String getElementName() { return ELEMENT; }
    
    /** Creates a new instance of XPEValueData */
    public XPEValueData(ValueData v, int indentLevel)
    {
        data = v;
        this.indentLevel = indentLevel;
    }

    protected void buildElement(Element e)
    {
        e.setAttribute(EL_NAME, data.getInfo());
        int cil = indentLevel + 1;
        this.appendXPE(new XPEData(data.getDataValue(), cil), e, cil);
        this.indent(e, indentLevel);
    }
}
